<?php
if (session_status() == PHP_SESSION_NONE) {
    session_start(); // Start session if not started
}
include_once 'config.php';
include_once 'report_vars.php';
$data = array();
if (isset($_SERVER['HTTP_AUTHORIZATION'])) {
    $key = $_SERVER['HTTP_AUTHORIZATION'];
} else {
    $key = 0; // Or provide a default value
}
$requestType = $_POST['requestType'];

if ('Bearer ' . $authkey == $key || $requestType==25) {
  if($requestType==1)   // Download centers.
 {
   $userclass=$_POST['classid'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centers = "select *  FROM exam_centres_$classprefix";
  $centers = $conn->prepare($centers);

  $centers->execute();
  $count_centers = $centers->rowCount();
  if ($count_centers > 0) {
    $setRows = $centers->fetchAll(PDO::FETCH_ASSOC);
    $data['centers'] = $setRows;
  }
  else {
        $data['centers'] = [];
  }
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==2)   // get all centers,todaycenters, pending for students
 {
  $pepDate = $_POST['pepDate'];
  $shift = $_POST['shift'];
  $userclass=$_POST['classid'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";
  $centers = "select count(*) as AllCenters  FROM $centerView";
  $centers = $conn->prepare($centers);
  $centers->execute();
  $centerlist = $centers->fetchAll(PDO::FETCH_ASSOC);
  $data['AllCenters'] = $centerlist[0]["AllCenters"];
  $query="SELECT distinct(`center_code`) FROM `attendance` where paper_date='$pepDate' and `classid`=$userclass and shift=$shift";
  $RCenters = $conn->prepare($query);
  $RCenters->execute();
  $Rcount=$RCenters->rowCount();
  $data['std_RCenters']=$Rcount;
  $query="select c.id,center_code,centre_name,total_std from ( select a.center_code,a.total as total_std  from ( SELECT center_code,count(roll_no) as total FROM $studentView as s, date_sheet as d where s.subject_code= d.subject_code and d.paper_date = '$pepDate' and d.classid = $userclass and d.shift = $shift and s.classid=d.classid  group by center_code ) as a left outer join ( SELECT a.center_code FROM attendance as a where a.paper_date = '$pepDate' and a.classid = $userclass and a.shift = $shift group by a.center_code ) as b on a.center_code = b.center_code where b.center_code is null ) as t, $centerView as c where t.center_code = c.centre_code and c.classid=$userclass order by c.id";
  $PCenters = $conn->prepare($query);
  $PCenters->execute();
  $Pcount=$PCenters->rowCount();
  $data['std_PCenters']=$Pcount;
  $data['TCenters']=$Rcount+$Pcount;

  $query="SELECT b.centre_name,  a.center FROM `staff_attendance` as a 
        inner join $centerView as b on a.center=b.centre_code
        where a.paper_date='$pepDate'  and a.classid=$userclass and a.shift =$shift and b.classid=a.classid GROUP BY a.center";
  $RCenters_staff = $conn->prepare($query);
  $RCenters_staff->execute();
  $Rcount_staff=$RCenters_staff->rowCount();
  $data['staff_RCenters']=$Rcount_staff;
  $data['staff_PCenters']=$Pcount; // today centers

  $query="SELECT b.centre_name,  a.center FROM `bundle_pictures` as a 
        inner join $centerView as b on a.center=b.centre_code
        where a.paper_date='$pepDate'  and a.classid=$userclass and a.shift =$shift and b.classid=a.classid GROUP BY a.center";
  $RCenters_bundles = $conn->prepare($query);
  $RCenters_bundles->execute();
  $Rcount_bundles=$RCenters_bundles->rowCount();
  $data['bundles_RCenters']=$Rcount_bundles;
  $query="SELECT b.center_code, c.centre_name FROM `date_sheet` AS a INNER JOIN $studentView AS b ON a.`subject_code` = b.subject_code INNER join $centerView as c on c.centre_code=b.center_code WHERE a.`paper_date` = '$pepDate' AND a.classid = $userclass AND a.`shift` = $shift and c.classid=a.classid and b.classid=a.classid and b.center_code not in (SELECT DISTINCT(d.`center`) FROM `bundle_pictures` as d where d.`paper_date`='$pepDate' and d.`classid`=$userclass and d.`shift`=$shift) GROUP by b.center_code";
  $PCenters_bundles = $conn->prepare($query);
  $PCenters_bundles->execute();
  $Pcount_bundles=$PCenters_bundles->rowCount();
  $data['bundles_PCenters']=$Pcount_bundles;
  
  $query="SELECT count(distinct(`roll_no`)) as totalstudents FROM `$studentView` s INNER join `date_sheet` d on s.`subject_code`=d.`subject_code` where d.`paper_date`='$pepDate' and d.`shift`=$shift and s.`classid`=$userclass and d.`classid`=s.`classid`";
  $RTotal = $conn->prepare($query);
  $RTotal->execute();
  $students = $RTotal->fetchAll(PDO::FETCH_ASSOC);
  $data['TotalStudents'] = $students[0]["totalstudents"];
  
  $query="SELECT count(DISTINCT(roll_no)) as absent FROM `attendance` where  paper_date ='$pepDate' and  classid=$userclass and shift=$shift  and attendence_status in (9)";
  $ATotal = $conn->prepare($query);
  $ATotal->execute();
  $absents = $ATotal->fetchAll(PDO::FETCH_ASSOC);
  $data['Absent'] = $absents[0]["absent"];
  
  $query="SELECT count(DISTINCT(roll_no)) as ufm FROM `attendance` where  paper_date ='$pepDate' and  classid=$userclass and shift=$shift  and attendence_status in (3,4,5,6,7,8)";
  $UFMTotal = $conn->prepare($query);
  $UFMTotal->execute();
  $ufms = $UFMTotal->fetchAll(PDO::FETCH_ASSOC);
  $data['UFMS'] = $ufms[0]["ufm"];
  
  $query="SELECT count(DISTINCT(centre)) as inspections FROM `inspectors_centres` i inner join app_user a on i.userid=a.userid where  duty_date ='$pepDate' and a.classid=$userclass";
  $iTotal = $conn->prepare($query);
  $iTotal->execute();
  $inspections = $iTotal->fetchAll(PDO::FETCH_ASSOC);
  $data['inspections'] = $inspections[0]["inspections"];
  $query="select d.subject_code , d.paper_name , d.shift , (select count(distinct s.center_code) from $studentView s where s.subject_code = d.subject_code) TotalCenters, (select count(distinct s.roll_no) from $studentView s where s.subject_code = d.subject_code) Totalstudents from date_sheet d where d.paper_date ='$pepDate' and d.shift=$shift and d.`classid`=$userclass and d.active=1";

  $Papers = $conn->prepare($query);
  $Papers->execute();
  $PapersList=$Papers->fetchAll(PDO::FETCH_ASSOC);
  $data['PapersList']=$PapersList; // today centers
  print_r(json_encode($data));
    $conn = null;
 }
  if($requestType==3)   // get attendance states
 {
  $pepDate = $_POST['pepDate'];
  $shift = $_POST['shift'];
  $userclass=$_POST['classid'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";

 $query="SELECT count(distinct(`roll_no`)) as totalstudents FROM `$studentView` s INNER join `date_sheet` d on s.`subject_code`=d.`subject_code` where d.`paper_date`='$pepDate' and d.`shift`=$shift and s.`classid`=$userclass and d.`classid`=s.`classid`";
  $RTotal = $conn->prepare($query);
  $RTotal->execute();
  $students = $RTotal->fetchAll(PDO::FETCH_ASSOC);
  $data['TotalStudents'] = $students[0]["totalstudents"];
  
  $query="SELECT count(DISTINCT(roll_no)) as absent FROM `attendance` where  paper_date ='$pepDate' and  classid=$userclass and shift=$shift  and attendence_status in (9)";
  $ATotal = $conn->prepare($query);
  $ATotal->execute();
  $absents = $ATotal->fetchAll(PDO::FETCH_ASSOC);
  $data['Absent'] = $absents[0]["absent"];
  
  $query="SELECT count(DISTINCT(roll_no)) as ufm FROM `attendance` where  paper_date ='$pepDate' and  classid=$userclass and shift=$shift  and attendence_status in (3,4,5,6,7,8)";
  $UFMTotal = $conn->prepare($query);
  $UFMTotal->execute();
  $ufms = $UFMTotal->fetchAll(PDO::FETCH_ASSOC);
  $data['UFMS'] = $ufms[0]["ufm"];
  
  $query="SELECT count(DISTINCT(centre)) as inspections FROM `inspectors_centres` i inner join app_user a on i.userid=a.userid where  duty_date ='$pepDate' and a.classid=$userclass";
  $iTotal = $conn->prepare($query);
  $iTotal->execute();
  $inspections = $iTotal->fetchAll(PDO::FETCH_ASSOC);
  $data['inspections'] = $inspections[0]["inspections"];


  $query="SELECT ID,SettingsName,classid,AllowStaffManagement,AllowStaffShuffling FROM `App_Settings` where  classid=$userclass and isSettingActive=1 Limit 1";
  $app_settings = $conn->prepare($query);
  $app_settings->execute();
  $settings = $app_settings->fetchAll(PDO::FETCH_ASSOC);
  $data['settings'] = $settings;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==4)   
 {
  $userclass=$_POST['classid'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $ExamInfo = "SELECT ap.AllowStaffManagement,ap.AllowStaffShuffling, (select count(*) FROM $centerView) TotalCenters,(SELECT count(*) as Refulsals FROM `staff` where ConfirmationStatus=0 and `classid`=$userclass) Refusals,(SELECT count(*) FROM `app_user` where active=1 and status=1 and `classid`=$userclass AND type=1) AllSups,(SELECT count(*) FROM `app_user` where active=1 and status=1 and `classid`=$userclass and isSetupComplete=1 AND type=1) activatedSups,(SELECT count(*) FROM $centerView esc where esc.centre_code not in (SELECT center_code FROM app_user WHERE `classid`=$userclass AND type=1)) MissingCenter FROM App_Settings ap WHERE ap.classid=$userclass and ap.isSettingActive=1;";
  $ExamInfo = $conn->prepare($ExamInfo);
  $ExamInfo->execute();
  $ExamInfolist = $ExamInfo->fetchAll(PDO::FETCH_ASSOC);
  $data['AllowStaffManagement'] = $ExamInfolist[0]["AllowStaffManagement"];
  $data['AllowStaffShuffling'] = $ExamInfolist[0]["AllowStaffShuffling"];
  $data['TotalCenters'] = $ExamInfolist[0]["TotalCenters"];
  $data['Refusals'] = $ExamInfolist[0]["Refusals"];
  $data['AllSups'] = $ExamInfolist[0]["AllSups"];
  $data['activatedSups'] = $ExamInfolist[0]["activatedSups"];
  $data['MissingCenter'] = $ExamInfolist[0]["MissingCenter"];
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==5)   // get Total Students
 {
  $pepDate= $_POST['pepDate'];
  $shift = $_POST['shift'];
  $userclass=$_POST['classid'];
  $penType=$_POST['pendencyType'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";
  if($penType==1)  // get student attendance pending centers
    $query="select c.id,t.center_code,centre_name,a.name , a.mobile,a.isSetupComplete,'$downloadLink' as downloadLink,total_std from ( select a.center_code,a.total as total_std  from ( SELECT center_code,count(roll_no) as total FROM $studentView as s, date_sheet as d where s.subject_code= d.subject_code and d.paper_date = '$pepDate' and d.classid = $userclass and d.shift = $shift and s.classid=d.classid  group by center_code ) as a left outer join ( SELECT a.center_code FROM attendance as a where a.paper_date = '$pepDate' and a.classid = $userclass and a.shift = $shift group by a.center_code ) as b on a.center_code = b.center_code where b.center_code is null ) as t, $centerView as c , app_user a  where t.center_code = c.centre_code and a.center_code = t.center_code and c.classid=$userclass and a.active = 1 order by c.id";
  else if($penType==2)  // get staff attendance pending centers
    $query="SELECT c.id,c.centre_code, c.centre_name,u.name,u.mobile,u.isSetupComplete,'https://bisekt.edu.pk/app/SEMS.apk' as downloadLink,(SELECT count(staff_id) as total FROM staff as s where s.ConfirmationStatus=1 AND s.active=1 and s.classid=$userclass and s.center_code=c.centre_code group by center_code) as total_std FROM `date_sheet` AS a INNER JOIN $studentView AS b ON a.`subject_code` = b.subject_code INNER join $centerView as c on c.centre_code=b.center_code Inner join `app_user` u ON u.center_code=c.centre_code WHERE a.`paper_date` = '$pepDate' AND a.classid = $userclass AND a.`shift` = $shift and c.classid=a.classid and b.classid=a.classid and b.center_code not in (SELECT DISTINCT(d.`center`) FROM `staff_attendance` as d where d.`paper_date`='$pepDate' and d.`classid`=$userclass and d.`shift`=$shift) GROUP by c.id";
   else if($penType==3)  // get bundles pending centers
    $query="SELECT c.id,c.centre_code, c.centre_name,u.name,u.mobile,u.isSetupComplete,'https://bisekt.edu.pk/app/SEMS.apk' as downloadLink,0 as total_std FROM `date_sheet` AS a INNER JOIN $studentView AS b ON a.`subject_code` = b.subject_code INNER join $centerView as c on c.centre_code=b.center_code Inner join `app_user` u ON u.center_code=c.centre_code WHERE a.`paper_date` = '$pepDate' AND a.classid = $userclass AND a.`shift` = $shift and c.classid=a.classid and b.classid=a.classid and b.center_code not in (SELECT DISTINCT(d.`center`) FROM `bundle_pictures` as d where d.`paper_date`='$pepDate' and d.`classid`=$userclass and d.`shift`=$shift) GROUP by c.id";
  $PCenters = $conn->prepare($query);
  $PCenters->execute();
  $centersList = $PCenters->fetchAll(PDO::FETCH_ASSOC);
  $data['Information'] = $centersList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==6)   // get UFMs
 {
  $pepDate= $_POST['pepDate'];
  $shift = $_POST['shift'];
  $userclass=$_POST['classid'];
  $dateFlag=$_POST['applyDate'];
  $dateClause=" a.paper_date='$pepDate' AND ";
  if($dateFlag==0)
    $dateClause=" ";
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";

  $query="select c.centre_name as center_name,s.paper_name, b.st_name,b.f_name,b.classid,b.year,a.`sub_code` as subject,a.`roll_no`,c.id as `center_code`,a.`exam_code`,b.reg_no,a.`script_number`,a.`paper_date`,`attendance_picture`,a.`attendence_status` as attendence_status,'0' AS studentpicture
        from attendance as a,$studentView as b,date_sheet s,$centerView c where $dateClause a.classid=$userclass AND a.shift=$shift AND a.roll_no=b.roll_no  AND a.attendence_status in (3,4,5,6,7,8) AND a.sub_code=s.subject_code AND a.center_code=c.centre_code group by a.roll_no,subject order by a.roll_no,a.`sub_code` desc";
  $ufm = $conn->prepare($query);
  $ufm->execute();
  $ufmList=[];
  $ufmList = $ufm->fetchAll(PDO::FETCH_ASSOC);
  $length = count($ufmList); 
  for ($x = 0; $x <$length; $x++) {
  $ufmList[$x]["attendance_picture"]=$miscImagesLink.$ufmList[$x]["attendance_picture"]."?alt=media";
  $ufmList[$x]["studentpicture"]=getStudentImageLink($ufmList[$x]);
}
  $data['UFMList'] = $ufmList;
  print_r(json_encode($data));
    $conn = null;
 }

 if($requestType==7)   // get all Inspections
 {
  $pepDate= $_POST['pepDate'];
  $userclass=$_POST['classid'];
  $dateFlag=$_POST['applyDate'];
  $dateClause=" i.duty_date='$pepDate' AND ";
  if($dateFlag==0)
    $dateClause=" ";
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";

  $query="SELECT `duty_id`,i.`userid`,esc.id as centerNo,esc.centre_name, a.name,a.mobile,a.isSetupComplete,'$downloadLink' as downloadLink, `duty_date`,`checked_in`,`checked_out`,`ISTIMEOK_IN`,`ISTIMEOK_OUT`,`cin_lat`,`cin_long`,`cout_lat`,`cout_long`,`report_status` FROM `inspectors_centres` i INNER JOIN exam_centres_hssc esc on i.centre=esc.centre_code INNER JOIN app_user a ON i.userid=a.userid WHERE $dateClause a.type=3 and a.active=1 and a.status=1 and a.classid=$userclass order by i.duty_date,centerNo,`checked_in` ASC";
  $inspections = $conn->prepare($query);
  $inspections->execute();
  $inspectionsList=[];
  $inspectionsList = $inspections->fetchAll(PDO::FETCH_ASSOC);
   $data['inspectionsList'] = $inspectionsList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==8)   // get all inspections
 {
  $duty_id= $_POST['duty_id'];
  $user_id=$_POST['user_id'];
  $userclass=$_POST['classid'];
  $query="SELECT b.qusestion_title,a.remarks,b.answer_type FROM `inspector_reports` as a inner join inspector_question as b on a.question_id=b.question_id where a.classid=$userclass and a.duty_id=$duty_id and a.user_id=$user_id order by b.answer_type DESC";
  $questionReplies = $conn->prepare($query);
  $questionReplies->execute();
  $questionRepliesList=[];
  $questionRepliesList = $questionReplies->fetchAll(PDO::FETCH_ASSOC);
  $length = count($questionRepliesList); 
  for ($x = 0; $x <$length; $x++) {
  if($questionRepliesList[$x]['answer_type']=="3")
    $questionRepliesList[$x]["remarks"]=$miscImagesLink.$questionRepliesList[$x]["remarks"]."?alt=media";
}
   $data['questionsList'] = $questionRepliesList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==9)   // get refusals
 {
  $userclass=$_POST['classid'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $query="SELECT s.staff_id,s.name,s.mobile,s.role,c.id as cno from staff s inner join $centerView c on s.center_code=c.centre_code where s.classid=$userclass and s.ConfirmationStatus=0 order by c.id";
  $refusals = $conn->prepare($query);
  $refusals->execute();
  $refusalsList=[];
  $refusalsList = $refusals->fetchAll(PDO::FETCH_ASSOC);
  $data['refusalsList'] = $refusalsList;
  print_r(json_encode($data));
    $conn = null;
 }
  if($requestType==10)   // get all superintendents and setupcompleted
 {
  $userclass=$_POST['classid'];
  $penType=$_POST['pendencyType'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";
  if($penType==1)  // get all Superintendents
    $query="select c.id,c.centre_code,centre_name,a.name , a.mobile,a.isSetupComplete,'$downloadLink' as downloadLink,0 as total_std FROM app_user a inner join $centerView c where a.center_code = c.centre_code and a.classid=$userclass and a.active = 1 and a.status = 1 order by c.id";
  else if($penType==2)  // get staff attendance pending centers
    $query="select c.id,c.centre_code,centre_name,a.name , a.mobile,a.isSetupComplete,'$downloadLink' as downloadLink,0 as total_std FROM app_user a inner join $centerView c where a.center_code = c.centre_code and a.classid=$userclass and a.active = 1 and a.status = 1 and a.isSetupComplete=1 order by c.id";
   else if($penType==3)  // get bundles pending centers
    $query="select c.id,c.centre_code,centre_name,a.name , a.mobile,a.isSetupComplete,'$downloadLink' as downloadLink,0 as total_std FROM app_user a inner join $centerView c where a.center_code = c.centre_code and a.classid=$userclass and a.active = 1 and a.status = 1 and a.isSetupComplete=0 order by c.id";
   else if($penType==4)
  $query="SELECT esc.ID,esc.centre_name,esc.centre_code FROM $centerView esc where esc.centre_code not in (SELECT center_code FROM app_user WHERE `classid`=$userclass AND type=1 AND active=1 AND status=1)";
  $info = $conn->prepare($query);
  $info->execute();
  $infoList = $info->fetchAll(PDO::FETCH_ASSOC);
  $data['Information'] = $infoList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==11)   // get Attendance record for Memo
 {
  $userclass=$_POST['classid'];
  $subCode=$_POST['SubjectCode'];
  $centerCode=$_POST['centerCode'];
  $pepDate= $_POST['pepDate'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";
  // first determine exam for which we need examCode
  $query="select exam_code FROM $studentView where classid=$userclass AND subject_code=$subCode LIMIT 0,1";
  $info = $conn->prepare($query);
  $info->execute();
  $ExamCodeList = $info->fetchAll(PDO::FETCH_ASSOC);
  $ExamCode=0;
  $length = count($ExamCodeList); 
  if($length>0)
    $ExamCode=$ExamCodeList[0]['exam_code'];
  
  $query="SELECT b.bank_code,b.bank_name FROM `banks` b INNER JOIN exam_centres_hssc esc on b.bank_code=esc.campCode WHERE esc.centre_code='$centerCode' and b.classid=$userclass";
  $banks = $conn->prepare($query);
  $banks->execute();
  $banksList = $banks->fetchAll(PDO::FETCH_ASSOC);

  $query="SELECT a.name FROM `app_user` a WHERE a.center_code='$centerCode' and a.classid=$userclass and a.type=1";
  $sups = $conn->prepare($query);
  $sups->execute();
  $supsList = $sups->fetchAll(PDO::FETCH_ASSOC);
  
  // now retrieve attendance information (rollnumber,attendanceStatus)
  $query="SELECT CAST(a.roll_no AS INTEGER) as roll_no,a.attendence_status FROM `attendance` a WHERE a.center_code='$centerCode' and a.classid=$userclass and a.sub_code='$subCode' and a.paper_date='$pepDate' order by roll_no ASC";
  $attendance = $conn->prepare($query);
  $attendance->execute();
  $attendanceList = $attendance->fetchAll(PDO::FETCH_ASSOC);
  $branchCode="0";
  $branchName="NA";
  $banklength = count($banksList); 
  if($banklength>0)
  {
    $branchCode=$banksList[0]['bank_code'];
  $branchName=$banksList[0]['bank_name'];
  }
  $supName="NA";
  $suplength = count($supsList); 
  if($suplength>0)
  {
  $supName=$supsList[0]['name'];
  }
  $MemoInfo = array("ExamCode"=>"$ExamCode", "branchCode"=>"$branchCode","branchName"=>"$branchName","supName"=>"$supName");

 $data['MemoInfo'] = $MemoInfo;
 $data['Attendance'] = $attendanceList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==12)   // get all Centers
 {
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$userclass=$_POST['classid'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
$centerView="exam_centres_$classprefix";
$session=0; 
$centerList = [];
if($token==$sessionID)
  {
    $query="select id as cno,centre_code as center_code,centre_name as center_name FROM $centerView";
  $center = $conn->prepare($query);
  $center->execute();
  $centerList = $center->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
  }
 $data=array("Session"=>$session, "centerlist"=>$centerList);
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==13)   // get all Centers
 {
  $userclass=$_POST['classid'];
  $CenterCode=$_POST['CenterCode'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $studentView="std_subjects_$classprefix";
  $query="select ds.id,paper_name,ds.subject_code,ds.classid,paper_date,start_time  ,end_time,ds.shift,active from date_sheet ds inner join $studentView std on (ds.classid=std.classid and ds.subject_code = std.subject_code) where ds.classid=std.classid and ds.subject_code = std.subject_code AND std.classid = $userclass AND std.center_code=$CenterCode group by ds.id ORDER BY ds.paper_date ASC";
  $paper = $conn->prepare($query);
  $paper->execute();
  $paperList = $paper->fetchAll(PDO::FETCH_ASSOC);
  $data['Papers']=$paperList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==14)   // get Attendance record for Attendance Sheet
 {
  $userclass=$_POST['classid'];
  $subCode=$_POST['SubjectCode'];
  $centerCode=$_POST['centerCode'];
  $pepDate= $_POST['pepDate'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerView="exam_centres_$classprefix";
  $studentView="std_subjects_$classprefix";
  // Retrieve attendance information (rollnumber,attendanceStatus)
  $query="SELECT s.st_name,CAST(s.roll_no AS INTEGER) as roll_no,s.exam_code,a.script_number,a.attendence_status FROM `attendance` a inner join $studentView s on a.roll_no=s.roll_no AND a.sub_code=s.subject_code and a.center_code=s.center_code  WHERE a.center_code='$centerCode' and s.center_code='$centerCode' and a.classid=$userclass and a.sub_code='$subCode' and s.subject_code='$subCode' and a.paper_date='$pepDate' order by roll_no ASC";
  $attendance = $conn->prepare($query);
  $attendance->execute();
  $attendanceList = $attendance->fetchAll(PDO::FETCH_ASSOC);
  $data['Attendance'] = $attendanceList;
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==15)
 {
  $messageText = $_POST['messageText'];
  $MessageTarget = $_POST['MessageTarget'];
  $classid = $_POST['classid'];
  $ImageUrls = $_POST['imageUrls'];
  $ImageUrls=trim($ImageUrls,',');
  $q = "INSERT INTO `Messages`(`messageText`, `MessageTarget`, `classid`, `ImageUrls`) VALUES (:messageText, :MessageTarget, :classid, :ImageUrls)";
      $record = $conn->prepare($q);
      $record->bindParam(':messageText', $messageText);
      $record->bindParam(':MessageTarget', $MessageTarget);
      $record->bindParam(':classid', $classid);
      $record->bindParam(':ImageUrls', $ImageUrls);
      $result = $record->execute();
   if($result)
{
    $data["MessageID"]=$conn->lastInsertId();
$data["notificationsdownloadlink"]=$notificationImagesLink;
}
   else
    $data["MessageID"]=0;
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==16)   // record message delivery log
 {
  $messageID = $_POST['messageID'];
  $userID = $_POST['userID'];
  $deliveryTime = $_POST['deliveryTime'];
   $q = "INSERT INTO `MessageLog`(`MessageID`, `ViewerID`, `DeliveryTime`)  VALUES (:messageID, :userID, :deliveryTime)";
      $record = $conn->prepare($q);
      $record->bindParam(':messageID', $messageID);
      $record->bindParam(':userID', $userID);
      $record->bindParam(':deliveryTime', $deliveryTime);
      $result = $record->execute();
   $conn = null;
}
if($requestType==17)   // Retrieve Notification Channels
 {
  $query="select * from NotificationTopics where isActive=1";
  $paper = $conn->prepare($query);
  $paper->execute();
  $ChannelsList = $paper->fetchAll(PDO::FETCH_ASSOC);
  $data['channels']=$ChannelsList;
  print_r(json_encode($data));
}
if($requestType==18)   // Retrieve Notification Channels
 {
  $userType = $_POST['userType'];
  $query="select * from NotificationTopics where UserType in(0,$userType) and isActive=1";
  $channel = $conn->prepare($query);
  $channel->execute();
  $channelList = $channel->fetchAll(PDO::FETCH_ASSOC);
  $data['channels']=$channelList;
  print_r(json_encode($data));
}
if($requestType==19)   // Retrieve Notification Channels
 {
$data["Success"]=0;
$MessagDeactivationList = $_POST['MessagDeactivationList'];
 $query="select * from NotificationTopics where isActive=1";
  $topics = $conn->prepare($query);
  $topics->execute();
  $topicsList = $topics->fetchAll(PDO::FETCH_ASSOC);
  $length = count($topicsList);
  // now set all previous channels to deactivate
  $q2 = "update `NotificationTopics` set `isActive`=0";
  $topics= $conn->prepare($q2);
  $result = $topics->execute(); 
  if($length>0){
    foreach ($topicsList as $topic) {
   $qinsert = "INSERT INTO `NotificationTopics`(`UserType`, `Description`,`isActive`) VALUES (:UserType,:Description,1)";
      $record = $conn->prepare($qinsert);
      $record->bindParam(':UserType',$topic['UserType']);
      $record->bindParam(':Description',$topic['Description']);
     $result = $record->execute();
}
  }
  if(strlen($MessagDeactivationList)>0)
  {
  $q2 = "update `Messages` set `Active`=0 where MessageTarget in ($MessagDeactivationList)";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  }
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==20)   // Retrieve Messages
 {
  $query="select ID as ID,ID as MessageID,messageText,MessageTarget,classid,ImageUrls,MessageDate,1 as isViewed from Messages where Active=1 ORDER by ID,MessageTarget DESC";
  $Message = $conn->prepare($query);
  $Message->execute();
  $MessageList = $Message->fetchAll(PDO::FETCH_ASSOC);
  $data['Messages']=$MessageList;
  print_r(json_encode($data));
}
if($requestType==21)   // De-Activate Messages of A channel
 {
$data["Success"]=0;
$DeactivationUserType = $_POST['DeactivationUserType'];
$q2 = "update `Messages` set `Active`=0 where MessageTarget=$DeactivationUserType";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==22)   // delete a message
 {
$data["Success"]=0;
$MessageID = $_POST['MessageID'];
$q2 = "Delete from `Messages` where ID=$MessageID";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==23)   // enable-disable Staff Management
 {
$data["Success"]=0;
 $enableStatus = $_POST['enableStatus'];
 $classid = $_POST['classid'];
$q2 = "update App_Settings set AllowStaffManagement=$enableStatus where classid=$classid";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==24)   // enable-disable Staff Management
 {
$data["Success"]=0;
 $enableStatus = $_POST['enableStatus'];
 $classid = $_POST['classid'];
$q2 = "update App_Settings set  AllowStaffShuffling=$enableStatus where classid=$classid";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==25)   // Retrieve Messages for UserType
 {
  $userType = $_POST['userType'];
  $query="select ID as ID,ID as MessageID,messageText,MessageTarget,classid,ImageUrls,MessageDate,1 as isViewed from Messages where Active=1 AND MessageTarget in (0,$userType) ORDER by ID,MessageTarget DESC";
  $Message = $conn->prepare($query);
  $Message->execute();
  $MessageList = $Message->fetchAll(PDO::FETCH_ASSOC);
  $data['Messages']=$MessageList;
  print_r(json_encode($data));
}
if($requestType==26)   // Retrieve Schedule Papers for a Class Type
 {
  $classid = $_POST['classid'];
  $sessionID = $_POST['sessionID'];
  $token=$_SESSION['session_token'];
  $accessrequired=$_POST['accessrequired'];
  $username=$_POST['username'];
  $access=isAccess($conn,$username,$accessrequired);
  if($sessionID==$token && $access==true)
  {
     $query="select id as ID,paper_name,subject_code,classid,paper_date,start_time,end_time,shift,active from date_sheet where classid=$classid ORDER by classid,paper_date ASC";
  $Papers = $conn->prepare($query);
  $Papers->execute();
  $PapersList = $Papers->fetchAll(PDO::FETCH_ASSOC);
  $data=array("Session"=>1, "Papers"=>$PapersList, "Token"=>$token);
  }
  else 
  {
    $data=array("Session"=>0, "Papers"=>[], "Token"=>$token);
  }
  print_r(json_encode($data));
}
if($requestType==27)   // delete a paper
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$PaperID = $_POST['PaperID'];
$q2 = "Delete from `date_sheet` where ID=$PaperID";
  $papers= $conn->prepare($q2);
  $result = $papers->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}

if($requestType==28)   // add a paper
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$subject_code = $_POST['subject_code'];
$paper_name = $_POST['paper_name'];
$classid = $_POST['classid'];
$paper_date = $_POST['paper_date'];
$start_time = $_POST['start_time'];
$end_time = $_POST['end_time'];
$shift = $_POST['shift'];
$active = $_POST['active'];
$isEnforce=$_POST['isEnforce'];
$ExistingCount=0;
// if isEnforce=0 then check for existing paper otherwise don't
if($isEnforce==0)
{
  $q2 = "select * from date_sheet where subject_code=$subject_code AND classid=$classid";
  $papers= $conn->prepare($q2);
  $result = $papers->execute(); 
  $ExistingCount = $papers->rowCount();
}
else 
  $ExistingCount=0;
if($ExistingCount>0)
  // return and give message that paper already exist
  $data["Success"]=1;
else 
{
  // insert paper
  $q = "INSERT INTO `date_sheet`(`paper_name`, `subject_code`, `classid`, `paper_date`, `start_time`, `end_time`, `shift`, `active`) VALUES (:paper_name, :subject_code, :classid, :paper_date, :start_time, :end_time, :shift, :active)";
      $record = $conn->prepare($q);
      $record->bindParam(':paper_name', $paper_name);
      $record->bindParam(':subject_code', $subject_code);
      $record->bindParam(':classid', $classid);
      $record->bindParam(':paper_date', $paper_date);
      $record->bindParam(':start_time', $start_time);
      $record->bindParam(':end_time', $end_time);
      $record->bindParam(':shift', $shift);
      $record->bindParam(':active', $active);
      $result = $record->execute();
   if($result)
    $data["Success"]=2;
   else
    $data["Success"]=3;

 ///
}
print_r(json_encode($data));
}
if($requestType==29)   // update a paper
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$paperID = $_POST['paperID'];
$subject_code = $_POST['subject_code'];
$paper_name = $_POST['paper_name'];
$classid = $_POST['classid'];
$paper_date = $_POST['paper_date'];
$start_time = $_POST['start_time'];
$end_time = $_POST['end_time'];
$shift = $_POST['shift'];
$active = $_POST['active'];
$isEnforce=$_POST['isEnforce'];
$ExistingCount=0;
// if isEnforce=0 then check for existing paper otherwise don't
if($isEnforce==0)
{
  $q2 = "select * from date_sheet where subject_code=$subject_code AND classid=$classid And ID<>$paperID";
  $papers= $conn->prepare($q2);
  $result = $papers->execute(); 
  $ExistingCount = $papers->rowCount();
}
else 
  $ExistingCount=0;
if($ExistingCount>0)
  // return and give message that paper already exist
  $data["Success"]=1;
else 
{
  // insert paper
  $q = "Update `date_sheet` set `paper_name`=:paper_name,`subject_code`=:subject_code, `classid`=:classid, `paper_date`=:paper_date, `start_time`=:start_time, `end_time`=:end_time, `shift`=:shift, `active`=:active where ID=$paperID";
      $record = $conn->prepare($q);
      $record->bindParam(':paper_name', $paper_name);
      $record->bindParam(':subject_code', $subject_code);
      $record->bindParam(':classid', $classid);
      $record->bindParam(':paper_date', $paper_date);
      $record->bindParam(':start_time', $start_time);
      $record->bindParam(':end_time', $end_time);
      $record->bindParam(':shift', $shift);
      $record->bindParam(':active', $active);
      $result = $record->execute();
   if($result)
    $data["Success"]=2;
   else
    $data["Success"]=3;

 ///
}
print_r(json_encode($data));
}
if($requestType==30)   // Retrieve Staff
 {
  $recordsPerPage=10;
  $userclass=$_POST['classid'];
  $recIndex=$_POST['recIndex'];
  $sessionID = $_POST['sessionID'];
  $token=$_SESSION['session_token'];
  $accessrequired=$_POST['accessrequired'];
  $username=$_POST['username'];
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $access=isAccess($conn,$username,$accessrequired);

  if($sessionID==$token && $access==true)
  {
  $query = "SELECT staff_id,name as s_name,mobile,cnic as CNIC, c.centre_name as c_name,c.centre_code,c.id as center_no,ConfirmationStatus,role,ac_no,adress,posting,designation,active FROM `staff` s INNER JOIN exam_centres_$classprefix c ON s.center_code=c.centre_code WHERE s.classid=:classid ORDER BY c.id,s.role,s.staff_id ASC LIMIT $recIndex,$recordsPerPage";
  $suplist = $conn->prepare($query);
  $suplist->bindParam(':classid', $userclass);
  $suplist->execute();
  $suplist = $suplist->fetchAll(PDO::FETCH_ASSOC);
  $data=array("Session"=>1, "stafflist"=>$suplist, "Token"=>$token);
  }
  else 
    $data=array("Session"=>0, "stafflist"=>[], "Token"=>$token);
  print_r(json_encode($data));
}
if($requestType==31)   // delete staff
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$staffID = $_POST['StaffID'];
$role = $_POST['role'];
$centerCode = $_POST['centerCode'];
$mobileNumber = $_POST['mobileNumber'];
$userclass = $_POST['classid'];
$data["Success"]=0;
$q2 = "delete from `staff` where staff_id=$staffID";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
if($role==1 || $role==17)
{
  $q2 = "delete from `app_user` where classid=$userclass AND type=$role AND center_code=$centerCode AND mobile=$mobileNumber";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
}
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==32)   // add Exam Staff 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$classid = $_POST['classid'];
$role = $_POST['role'];
$centerno = $_POST['centerno'];
$sname = $_POST['sname'];
$mobileNumber = $_POST['mobileNumber'];
$CNICNumber = $_POST['CNICNumber'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
$baccount = $_POST['ac_no'];
$isEnforce=$_POST['isEnforce'];
$identifier=$_POST['identifier'];
$active=$_POST['active'];    // identifies that cnic is used as username or mobile
$centerCode="0";
$classprefix="ssc";
  if($classid=="2")
  $classprefix="hssc";
$center = "Select centre_code from  `exam_centres_$classprefix` WHERE id=:centerno";
$cent = $conn->prepare($center);
$cent->bindParam(':centerno', $centerno);
$cent->execute();
$centlist = $cent->fetchAll(PDO::FETCH_ASSOC);
$count_center=0;
$count_center = $cent->rowCount();
if($count_center>0)
{
  $centerCode=$centlist[0]['centre_code'];
  $ExistingCount=0;
// if isEnforce=0 then check for existing staff otherwise don't
  if($isEnforce==0)
{
  if($identifier==1) // means cnic is used as username
    $query = "Select * from  `staff` WHERE cnic=:CNICNumber AND classid=:classid";
  else
    $query = "Select * from  `staff` WHERE `mobile`=:mobileNumber AND classid=:classid";
  $change = $conn->prepare($query);
  if($identifier==1)
  $change->bindParam(':CNICNumber', $CNICNumber);
  else
  $change->bindParam(':mobileNumber', $mobileNumber);
  $change->bindParam(':classid', $classid);
  $change->execute();
  $count_staff=0;
  $count_staff = $change->rowCount();
  $count_appUser=0;

  if($role==1 || $role==17)
  {
    $username=$mobileNumber;
  if($identifier==1)
    $username=$CNICNumber;
  $query2 = "Select * from  `app_user` WHERE `username`=:username AND classid=:classid";
  $change2 = $conn->prepare($query2);
  $change2->bindParam(':classid', $classid);
  $change2->bindParam(':username', $username);
  $change2->execute();
  $count_appUser = $change2->rowCount();
  }
if ((($role==1 || $role==17) && ($count_appUser>0)) 
  || 
  (($role==11 || $role==4 || $role==5) && ($count_staff>0))
) 
   $ExistingCount=1;  // means already exist.
} // end of isEnforce
else
$ExistingCount=0;
if($ExistingCount>0)  // return and give message that staff already exist
  $data["Success"]=1;
else // make all entries here
{
    if($role==11 || $role==4 || $role==5)
    {
      $q = "INSERT INTO `staff`(`name`, `mobile`, `role`, `center_code`, `cnic`, `ac_no`, `added_by`, `adress`, `classid`,`active`,`ConfirmationStatus`,`designation`,`posting`) VALUES (:name, :mobile, :role, :center_code, :cnic, :account, -500, :adress,:classid,:active,:ConfirmationStatus,:designation,:posting)";
      $report = $conn->prepare($q);
      $report->bindParam(':name', $sname);
      $report->bindParam(':mobile', $mobileNumber);
      $report->bindParam(':role', $role);
      $report->bindParam(':center_code', $centerCode);
      $report->bindParam(':cnic', $CNICNumber);
      $report->bindParam(':account', $baccount);
      $report->bindParam(':adress', $posting);
      $report->bindParam(':designation', $designation);
      $report->bindParam(':posting', $posting);
      $report->bindParam(':classid', $classid);
      $report->bindParam(':active', $active);
      $report->bindParam(':ConfirmationStatus', $active);
      $result = $report->execute();
    }
    else 
      $result=true;

      $result2=0;
     if($result && ($role==1 || $role==17))
    {
    $u_name=$mobileNumber;
    if($identifier==1)
    $u_name=$CNICNumber;  
    $u_pass=md5(md5($u_name));
    $q2 = "INSERT INTO `app_user`(`name`,`username`,`password`,`mobile`, `type`, `center_code`,`designation`,`posting`,`classid`,`status`,`active`,`ConfirmationStatus`) VALUES (:name,:username,:password, :mobile, :role, :center_code, :designation,:posting,:classid,1,1,1)";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':name', $sname);
      $report2->bindParam(':username', $u_name);
      $report2->bindParam(':password', $u_pass);
      $report2->bindParam(':mobile', $mobileNumber);
      $report2->bindParam(':role', $role);
      $report2->bindParam(':center_code', $centerCode);
      $report2->bindParam(':designation', $designation);
      $report2->bindParam(':posting', $posting);
      $report2->bindParam(':classid', $classid);
      $result2 = $report2->execute();
    }
    if ((($role==1 || $role==17) && ($result && $result2)) ||  (($role==11 || $role==4 || $role==5) && ($result)))
   $data["Success"]=2; // means inserted successfully
  else $data["Success"]=3; // means inserted failed
}
} // end of center exist 
else
{
  $data["Success"]=4;  // center does not exist
}
print_r(json_encode($data));
}

if($requestType==33)   // update Exam Staff 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$classid = $_POST['classid'];
$role = $_POST['role'];
$centerno = $_POST['centerno'];
$staff_id = $_POST['staff_id'];
$oldusername = $_POST['oldusername'];
$sname = $_POST['sname'];
$mobileNumber = $_POST['mobileNumber'];
$CNICNumber = $_POST['CNICNumber'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
$baccount = $_POST['ac_no'];
$isEnforce=$_POST['isEnforce'];
$identifier=$_POST['identifier'];
$active=$_POST['active'];    // identifies that cnic is used as username or mobile
$centerCode="0";
$classprefix="ssc";
  if($classid=="2")
  $classprefix="hssc";
$center = "Select centre_code from  `exam_centres_$classprefix` WHERE id=:centerno";
$cent = $conn->prepare($center);
$cent->bindParam(':centerno', $centerno);
$cent->execute();
$centlist = $cent->fetchAll(PDO::FETCH_ASSOC);
$count_center=0;
$count_center = $cent->rowCount();
if($count_center>0)
{
  $centerCode=$centlist[0]['centre_code'];
  $ExistingCount=0;
// if isEnforce=0 then check for existing staff otherwise don't
  if($isEnforce==0)
{
  if($identifier==1) // means cnic is used as username
    $query = "Select * from  `staff` WHERE cnic=:CNICNumber AND classid=:classid AND staff_id<>$staff_id";
  else
    $query = "Select * from  `staff` WHERE `mobile`=:mobileNumber AND classid=:classid AND staff_id<>$staff_id";
  $change = $conn->prepare($query);
  if($identifier==1)
  $change->bindParam(':CNICNumber', $CNICNumber);
  else
  $change->bindParam(':mobileNumber', $mobileNumber);
  $change->bindParam(':classid', $classid);
  $change->execute();
  $count_staff=0;
  $count_staff = $change->rowCount();
if ($count_staff>0)
   $ExistingCount=1;  // means already exist.
} // end of isEnforce
else
$ExistingCount=0;
if($ExistingCount>0)  // return and give message that staff already exist
  $data["Success"]=1;
else // make all entries here
{
  if($role==11 || $role==4 || $role==5)
  {
    $q = "update `staff` set `posting`=:posting,`designation`=:designation, `name`=:name, `mobile`=:mobile, `role`=:role,`center_code`=:center_code,`cnic`=:cnic,`ac_no`=:account,`added_by`=-500,`adress`=:adress,`classid`=:classid,`active`=:active,`ConfirmationStatus`=:ConfirmationStatus where staff_id=:staff_id";
      $report = $conn->prepare($q);
      $report->bindParam(':name', $sname);
      $report->bindParam(':mobile', $mobileNumber);
      $report->bindParam(':role', $role);
      $report->bindParam(':center_code', $centerCode);
      $report->bindParam(':cnic', $CNICNumber);
      $report->bindParam(':account', $baccount);
      $report->bindParam(':adress', $posting);
      $report->bindParam(':posting', $posting);
      $report->bindParam(':designation', $designation);
      $report->bindParam(':classid', $classid);
      $report->bindParam(':active', $active);
      $report->bindParam(':ConfirmationStatus', $active);
      $report->bindParam(':staff_id', $staff_id);
      $result = $report->execute();
  }
  else 
    $result=true;

     if($result && ($role==1 || $role==17))
    {
    $u_name=$mobileNumber;
    if($identifier==1)
    $u_name=$CNICNumber;  
    $u_pass=md5(md5($u_name));
    $q2 = "update `app_user` set `name`=:name,`mobile`=:mobile,`type`=:role,`center_code`=:center_code,`designation`=:designation,`posting`=:posting,`classid`=:classid,`status`=:status,`active`=:active,`ConfirmationStatus`=:ConfirmationStatus where `username`=:username";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':name', $sname);
      $report2->bindParam(':mobile', $mobileNumber);
      $report2->bindParam(':role', $role);
      $report2->bindParam(':center_code', $centerCode);
      $report2->bindParam(':designation', $designation);
      $report2->bindParam(':posting', $posting);
      $report2->bindParam(':classid', $classid);
      $report2->bindParam(':status', $active);
      $report2->bindParam(':active', $active);
      $report2->bindParam(':ConfirmationStatus',$active);
      $report2->bindParam(':username', $oldusername);
      $result2 = $report2->execute();
    }
    if ((($role==1 || $role==17) && ($result && $result2)) ||  (($role==11 || $role==4 || $role==5) && ($result)))
   $data["Success"]=2; // means updated successfully
  else $data["Success"]=3; // means updation failed
}
} // end of center exist 
else
{
  $data["Success"]=4;  // center does not exist
}
print_r(json_encode($data));
}
if($requestType==34)   // search Staff
 {
  $sessionID = $_POST['sessionID'];
  $token=$_SESSION['session_token'];
  $userclass=$_POST['classid'];
  $SearchTerm=$_POST['SearchTerm'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  if(is_numeric($SearchTerm) && strlen($SearchTerm)<=4)
  $query = "SELECT staff_id,name as s_name,mobile,cnic as CNIC, c.centre_name as c_name,c.centre_code,c.id as center_no,ConfirmationStatus,role,adress,ac_no,active,s.posting,s.designation FROM `staff` s INNER JOIN exam_centres_$classprefix c ON s.center_code=c.centre_code WHERE s.classid=:classid AND c.id=$SearchTerm ORDER BY c.id,s.role,s.staff_id ASC";
  else 
  $query = "SELECT staff_id,name as s_name,mobile,cnic as CNIC, c.centre_name as c_name,c.centre_code,c.id as center_no,ConfirmationStatus,role,ac_no,adress,active,s.posting,s.designation FROM `staff` s INNER JOIN exam_centres_$classprefix c ON s.center_code=c.centre_code WHERE s.classid=:classid AND (c.centre_name like '%$SearchTerm%' || name like '%$SearchTerm%'  || cnic like '%$SearchTerm%'  || mobile like '%$SearchTerm%') ORDER BY c.id,s.role,s.staff_id ASC"; 
  $suplist=[];
  $session=0;
  if($token==$sessionID)
  {
  $suplist = $conn->prepare($query);
  $suplist->bindParam(':classid', $userclass);
  $suplist->execute();
  $suplist = $suplist->fetchAll(PDO::FETCH_ASSOC);
  $session=1;
  }
  $data=array("Session"=>$session, "stafflist"=>$suplist);
  print_r(json_encode($data));
} 
if($requestType==35)   // Retrieve Staff
 {

$recordsPerPage=20;
  $userclass=$_POST['classid'];
  $recIndex=$_POST['recIndex'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$session=0; 
$centerlist = [];
if($token==$sessionID)
  {
    $query = "select eh.id ,eh.centre_code , eh.centre_name , eh.campCode, au.name , au.mobile , au.isSetupComplete , au.active,au.status, (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 1 and s.active =1) Supdt, (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 4 and s.active =1) 'D/Supdt', (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 11 and s.active =1) 'AD/Supdt', (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 5 and s.active =1) Invg from exam_centres_$classprefix eh left JOIN app_user au on (au.classid = eh.classid and au.center_code=eh.centre_code and au.type = 1) where eh.classid = :classid order by eh.id LIMIT $recIndex,$recordsPerPage";
  $centerlist = $conn->prepare($query);
  $centerlist->bindParam(':classid', $userclass);
  $centerlist->execute();
  $centerlist = $centerlist->fetchAll(PDO::FETCH_ASSOC);
  }
  $data=array("Session"=>$session, "centerlist"=>$centerlist);
  print_r(json_encode($data));
}
if($requestType==36)   // search center
 {
  $userclass=$_POST['classid'];
  $SearchTerm=$_POST['SearchTerm'];
  $sessionID = $_POST['sessionID'];
  $token=$_SESSION['session_token'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $centerlist=[];
  $session=0;
  if(is_numeric($SearchTerm))
  $query = "select eh.id ,eh.centre_code , eh.centre_name,eh.campCode , au.name , au.mobile , au.isSetupComplete , au.active,au.status, (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 1 and s.active =1) Supdt, (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 4 and s.active =1) 'D/Supdt', (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 11 and s.active =1) 'AD/Supdt', (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 5 and s.active =1) Invg from exam_centres_$classprefix eh left JOIN app_user au on (au.classid = eh.classid and au.center_code=eh.centre_code and au.type = 1) where eh.classid = :classid AND eh.id=$SearchTerm  order by eh.id";
  else 
  $query = "select eh.id ,eh.centre_code , eh.centre_name , au.name , au.mobile , au.isSetupComplete , au.active,au.status, (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 1 and s.active =1) Supdt, (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 4 and s.active =1) 'D/Supdt', (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 11 and s.active =1) 'AD/Supdt', (select count(*) from staff s where s.classid = eh.classid and s.center_code=eh.centre_code and s.role = 5 and s.active =1) Invg from exam_centres_$classprefix eh left JOIN app_user au on (au.classid = eh.classid and au.center_code=eh.centre_code and au.type = 1) where eh.classid = :classid AND eh.centre_name like %$SearchTerm%  order by eh.id"; 
    if($token==$sessionID)
    {
      $centerlist = $conn->prepare($query);
      $centerlist->bindParam(':classid', $userclass);
      $centerlist->execute();
      $centerlist = $centerlist->fetchAll(PDO::FETCH_ASSOC);
    }
    $data=array("Session"=>$session, "centerlist"=>$centerlist);
  print_r(json_encode($data));
} 
if($requestType==37)   // retrieve center staff details
 {
  $userclass=$_POST['classid'];
  $SearchTerm=$_POST['SearchTerm'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $query = "select c.id,c.centre_name,staff_id,name,mobile,role,active from staff s inner join exam_centres_$classprefix c on s.center_code=c.centre_code where eh.classid = :classid AND c.id=$SearchTerm  order by role ASC";
  $staffdetails = $conn->prepare($query);
        $staffdetails->bindParam(':classid', $userclass);
  $staffdetails->execute();
  $count_sups=$staffdetails->rowCount();
  if ($count_sups > 0) {
    $staffdetails = $staffdetails->fetchAll(PDO::FETCH_ASSOC);
    $data['staffdetails'] = $staffdetails;
  }
  else {
        $data['staffdetails'] = [];
  }
  print_r(json_encode($data));
} 
if($requestType==38)   // Retrieve Inspectors
 {
  $userclass=$_POST['classid'];
  $sessionID = $_POST['sessionID'];
  $token=$_SESSION['session_token'];
  $accessrequired=$_POST['accessrequired'];
  $username=$_POST['username'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $access=isAccess($conn,$username,$accessrequired);
  $session=0;
  if($sessionID==$token && $access==true)
  {
  $query = "SELECT i.userid, i.name,i.username,i.mobile,i.posting,i.designation,i.classid,i.status,i.active,isSetupComplete 
        FROM app_user AS i WHERE i.type = 3 AND i.classid=:classid ORDER BY userid ASC";
  $inspectorslist = $conn->prepare($query);
        $inspectorslist->bindParam(':classid', $userclass);
  $inspectorslist->execute();
  $inspectorslist = $inspectorslist->fetchAll(PDO::FETCH_ASSOC);
  $session=1;
}
  $inspectorsInfo=[];
  for($i=0;$i<count($inspectorslist);$i++) {
    $userid= $inspectorslist[$i]['userid'];
   $query = "SELECT d.duty_id ,d.userid,c.id as cno,c.centre_name, d.duty_date,d.report_status
        FROM inspectors_centres d inner join exam_centres_$classprefix c ON d.centre=c.centre_code  WHERE  userid= $userid order by report_status DESC";
  $dutiesList = $conn->prepare($query);
  $dutiesList->execute();
  $dutiesList = $dutiesList->fetchAll(PDO::FETCH_ASSOC);
  $inspectorsInfo[$i]["inspector"]=$inspectorslist[$i];
  $inspectorsInfo[$i]["duties"]=$dutiesList;
}
$data=array("Session"=>$session, "inspectorslist"=>$inspectorsInfo);
print_r(json_encode($data));
} 
if($requestType==39)   // delete a duty
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$dutyID = $_POST['dutyID'];
$q2 = "Delete from `inspectors_centres` where duty_id=$dutyID";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==40)   // insert inspector exam duty
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$userid = $_POST['userid'];
$centerCode = $_POST['centerCode'];
$d_date = $_POST['d_date'];
$isEnforce=$_POST['isEnforce'];
$ExistingCount=0;
// if isEnforce=0 then check for existing paper otherwise don't
if($isEnforce==0)
{
  $q2 = "select * from inspectors_centres where duty_date='$d_date' AND centre='$centerCode'";
  $papers= $conn->prepare($q2);
  $result = $papers->execute(); 
  $ExistingCount = $papers->rowCount();
  if($ExistingCount>0) // means that inspection on the date already exist
    $data["Success"]=2;
  else 
  {
   $q2 = "select * from inspectors_centres where duty_date='$d_date' AND userid=$userid";
  $papers= $conn->prepare($q2);
  $result = $papers->execute(); 
  $ExistingCount = $papers->rowCount();
  if($ExistingCount>0) // means that this inspector have inspection on that date.
    $data["Success"]=3; 
  }  
}
else 
  $ExistingCount=0;
if($ExistingCount==0)
{
 $q = "INSERT INTO `inspectors_centres`(`userid`, `centre`, `duty_date`) VALUES (:userid, :centre, :duty_date)";
      $record = $conn->prepare($q);
      $record->bindParam(':userid', $userid);
      $record->bindParam(':centre', $centerCode);
      $record->bindParam(':duty_date', $d_date);
      $result = $record->execute();
   if($result)
    $data["Success"]=1;
   else
    $data["Success"]=0;
}
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==41)   // add Inspector 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$classid = $_POST['classid'];
$sname = $_POST['sname'];
$mobileNumber = $_POST['mobileNumber'];
$CNICNumber = $_POST['CNICNumber'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
$identifier=$_POST['identifier'];
$active=$_POST['active'];    // identifies that cnic is used as username or mobile
 $ExistingCount=0;
$username=$mobileNumber;
  if($identifier==1)
    $username=$CNICNumber;
  $query2 = "Select * from  `app_user` WHERE `username`=:username";
  $change2 = $conn->prepare($query2);
  $change2->bindParam(':username', $username);
  $change2->execute();
  $count_appUser = $change2->rowCount();
if($count_appUser>0)
  $data["Success"]=2;  // already exist
else {
  $u_name=$mobileNumber;
    if($identifier==1)
    $u_name=$CNICNumber;  
    $u_pass=md5(md5($u_name));
    $q2 = "INSERT INTO `app_user`(`name`,`username`,`password`,`mobile`, `type`,`designation`,`posting`,`classid`,`status`,`active`,`ConfirmationStatus`) VALUES (:name,:username,:password, :mobile,3,:designation,:posting,:classid,1,1,1)";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':name', $sname);
      $report2->bindParam(':username', $u_name);
      $report2->bindParam(':password', $u_pass);
      $report2->bindParam(':mobile', $mobileNumber);
      $report2->bindParam(':designation', $designation);
      $report2->bindParam(':posting', $posting);
      $report2->bindParam(':classid', $classid);
      $result2 = $report2->execute();
  if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
}
print_r(json_encode($data));
}

if($requestType==42)   // update Inspector 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$classid = $_POST['classid'];
$userid = $_POST['userid'];
$sname = $_POST['sname'];
$mobileNumber = $_POST['mobileNumber'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
$active=$_POST['active'];    // identifies that cnic is used as username or mobile // identifies that cnic is used as username or mobile
$q2 = "update `app_user` set `name`=:name,`mobile`=:mobile,`designation`=:designation,`posting`=:posting,`classid`=:classid,`status`=:status,`active`=:active,`ConfirmationStatus`=:ConfirmationStatus where `userid`=:userid";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':name', $sname);
      $report2->bindParam(':mobile', $mobileNumber);
      $report2->bindParam(':designation', $designation);
      $report2->bindParam(':posting', $posting);
      $report2->bindParam(':classid', $classid);
      $report2->bindParam(':status', $active);
      $report2->bindParam(':active', $active);
      $report2->bindParam(':ConfirmationStatus',$active);
      $report2->bindParam(':userid', $userid);
      $result2 = $report2->execute();
  if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
print_r(json_encode($data));
}
if($requestType==43)   // delete inspector
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$userID = $_POST['userID'];
$q2 = "Delete from `app_user` where userid=$userID";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
$q2 = "Delete from `inspectors_centres` where userid=$userID";   // no deletion for bank inspector will happen
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==44)   // Load Center Inspection Data
 {
$userclass=$_POST['classid'];
$centerCode=$_POST['centerCode'];
$sessionID = $_POST['sessionID'];
  $token=$_SESSION['session_token'];
  $accessrequired=$_POST['accessrequired'];
  $username=$_POST['username'];
  $access=isAccess($conn,$username,$accessrequired);
   $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $session=0;
  if($sessionID==$token && $access==true)
  {
     $query = "select ds.paper_date, count(std.roll_no) as TotalStudents from date_sheet ds inner join std_subjects_$classprefix std on (ds.classid=std.classid and ds.subject_code = std.subject_code) where ds.classid=std.classid and ds.subject_code = std.subject_code AND ds.shift=1 AND std.classid = :classid AND std.center_code=:centerCode group by ds.paper_date ORDER BY ds.paper_date ASC";
  $PapersList = $conn->prepare($query);
  $PapersList->bindParam(':classid', $userclass);
  $PapersList->bindParam(':centerCode', $centerCode);
  $PapersList->execute();
  $PapersList = $PapersList->fetchAll(PDO::FETCH_ASSOC);
  $session=1;
 }
 else 
  $PapersList = [];
  $PapersInfo=[];
  for($i=0;$i<count($PapersList);$i++) {
    $paper_date= $PapersList[$i]['paper_date'];
   $query2 = "SELECT i.duty_id, a.name, a.mobile,a.designation,a.posting,i.duty_date,i.report_status FROM app_user a INNER JOIN inspectors_centres i ON a.userid=i.userid WHERE a.classid=$userclass AND i.centre='$centerCode' AND i.duty_date='$paper_date' AND a.active=1 ";
  $dutiesList = $conn->prepare($query2);
  $dutiesList->execute();
  $dutiesList = $dutiesList->fetchAll(PDO::FETCH_ASSOC);
  $PapersInfo[$i]["papers"]=$PapersList[$i];
  $PapersInfo[$i]["duties"]=$dutiesList;
}
$data=array("Session"=>$session, "paperslist"=>$PapersInfo);
print_r(json_encode($data));
}
if($requestType==45)   // Load Center Inspection Data
 {
$userclass=$_POST['classid'];
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired);
$session=0; 
$inspectorsList=[]; 
if($sessionID==$token && $access==true)
  {
$query = "select userid,name,designation from app_user where classid=:classid And type=3 AND active=1 and status=1";
  $inspectorsList = $conn->prepare($query);
  $inspectorsList->bindParam(':classid', $userclass);
  $inspectorsList->execute();
  $inspectorsList = $inspectorsList->fetchAll(PDO::FETCH_ASSOC);
$session=1; 
}
$data=array("Session"=>$session, "inspectorslist"=>$inspectorsList);
print_r(json_encode($data));
}
if($requestType==46) // Load Inspection Questions
{
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired);
$session=0;  
$questionsList=[];
if($sessionID==$token && $access==true)
  {
$query = "select question_id,CONVERT(qusestion_title USING utf8mb4) AS questionTitle,answer_type,isActive from inspector_question order by answer_type ASC";
  $questionsList = $conn->prepare($query);
  $result=$questionsList->execute();
   $questionsList = $questionsList->fetchAll(PDO::FETCH_ASSOC);
  $session=1;
}
$data=array("Session"=>$session, "questionsList"=>$questionsList);
print_r(json_encode($data));
}
if($requestType==47)
{
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
  $qText = $_POST['qText'];
  $qType = $_POST['qType'];
  $isActive = $_POST['isActive'];
  $q = "INSERT INTO `inspector_question`(`qusestion_title`, `answer_type`, `isActive`) VALUES (:qusestion_title, :answer_type, :isActive)";
      $record = $conn->prepare($q);
      $record->bindParam(':qusestion_title', $qText);
      $record->bindParam(':answer_type', $qType);
      $record->bindParam(':isActive', $isActive);
      $result = $record->execute();
   if($result)
    $data["Success"]=1;
  else 
    $data["Success"]=2;
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==48)  // update inspection question
{
  $data["Success"]=0;
  $sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
  $question_id = $_POST['question_id'];
  $qText = $_POST['qText'];
  $qType = $_POST['qType'];
  $isActive = $_POST['isActive'];
  $q = "update `inspector_question` set `qusestion_title`=:qusestion_title, `answer_type`=:answer_type, `isActive`=:isActive where question_id=:question_id";
      $record = $conn->prepare($q);
      $record->bindParam(':question_id', $question_id);
      $record->bindParam(':qusestion_title', $qText);
      $record->bindParam(':answer_type', $qType);
      $record->bindParam(':isActive', $isActive);
      $result = $record->execute();
   if($result)
    $data["Success"]=1;
  else 
    $data["Success"]=0;
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==49)   // delete inspection question
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$question_id = $_POST['question_id'];
$q2 = "Delete from `inspector_question` where question_id=$question_id";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==50)   // Retrieve bank Inspectors
 {
  $userclass=$_POST['classid'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
$session=0; 
$inspectorslist = [];
if($token==$sessionID && $access==true)
  {
     $query = "SELECT i.userid, i.name,i.username,i.mobile,i.posting,i.designation,i.classid,i.status,i.active,isSetupComplete,bank_code,bank_name FROM app_user i inner join banks b on i.center_code=b.bank_code WHERE i.type = 7 AND i.classid=:classid ORDER BY userid ASC;";
  $inspectorslist = $conn->prepare($query);
        $inspectorslist->bindParam(':classid', $userclass);
  $inspectorslist->execute();
  $inspectorslist = $inspectorslist->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
  }

 $data=$data=array("Session"=>$session, "inspectorslist"=>$inspectorslist);
 print_r(json_encode($data));
}
if($requestType==51)   // Retrieve banks
 {
  $userclass=$_POST['classid'];
  $sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
$session=0; 
$bankslist = [];
if($token==$sessionID)
  {
    $query = "SELECT bank_code, bank_name FROM banks";
    //$query = "SELECT bank_code, bank_name FROM banks where classid=:classid;";
  $bankslist = $conn->prepare($query);
    //    $bankslist->bindParam(':classid', $userclass);
  $bankslist->execute();
  $bankslist = $bankslist->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
  }
  $data=array("Session"=>$session, "Bankslist"=>$bankslist);
 print_r(json_encode($data));
}
if($requestType==52)   // add bank Inspector 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$classid = $_POST['classid'];
$sname = $_POST['sname'];
$bankCode = $_POST['bankCode'];
$mobileNumber = $_POST['mobileNumber'];
$CNICNumber = $_POST['CNICNumber'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
$identifier=$_POST['identifier'];
$active=$_POST['active'];    // identifies that cnic is used as username or mobile
 $ExistingCount=0;
$username=$mobileNumber;
  if($identifier==1)
    $username=$CNICNumber;
  $query2 = "Select * from  `app_user` WHERE `username`=:username";
  $change2 = $conn->prepare($query2);
  $change2->bindParam(':username', $username);
  $change2->execute();
  $count_appUser = $change2->rowCount();
if($count_appUser>0)
  $data["Success"]=2;  // already exist
else {
  $u_name=$mobileNumber;
    if($identifier==1)
    $u_name=$CNICNumber;  
    $u_pass=md5(md5($u_name));
    $q2 = "INSERT INTO `app_user` (`name`, `username`, `password`, `mobile`, `type`, `designation`, `center_code`, `posting`, `classid`, `status`, `active`, `ConfirmationStatus`) 
VALUES (:name, :username, :password, :mobile, 7, :designation, :bank_code, :posting, :classid, 1, 1, 1);";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':name', $sname);
      $report2->bindParam(':username', $u_name);
      $report2->bindParam(':password', $u_pass);
      $report2->bindParam(':mobile', $mobileNumber);
      $report2->bindParam(':designation', $designation);
      $report2->bindParam(':bank_code', $bankCode);
      $report2->bindParam(':posting', $posting);
      $report2->bindParam(':classid', $classid);
      $result2 = $report2->execute();
  if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
}
print_r(json_encode($data));
}
if($requestType==53)   // update bank Inspector 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$classid = $_POST['classid'];
$userid = $_POST['userid'];
$sname = $_POST['sname'];
$mobileNumber = $_POST['mobileNumber'];
$bankCode = $_POST['bankCode'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
$active=$_POST['active'];    // identifies that cnic is used as username or mobile // identifies that cnic is used as username or mobile
 $ExistingCount=0;
 $q2 = "update `app_user` set `name`=:name,`mobile`=:mobile,`designation`=:designation,`posting`=:posting,`classid`=:classid,`status`=:status,`active`=:active,`ConfirmationStatus`=:ConfirmationStatus,center_code=:bank_code where `userid`=:userid";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':name', $sname);
      $report2->bindParam(':mobile', $mobileNumber);
      $report2->bindParam(':designation', $designation);
      $report2->bindParam(':posting', $posting);
      $report2->bindParam(':classid', $classid);
      $report2->bindParam(':status', $active);
      $report2->bindParam(':active', $active);
      $report2->bindParam(':ConfirmationStatus',$active);
      $report2->bindParam(':bank_code',$bankCode);
      $report2->bindParam(':userid', $userid);
      $result2 = $report2->execute();
  if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
print_r(json_encode($data));
}
if($requestType==54)   // Retrieve Recieved Student Attendance
 {
  $userclass=$_POST['classid'];
  $pepDate= $_POST['pepDate'];
  $shift = $_POST['shift'];
  $penType=$_POST['pendencyType'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $data=array();
  $query = "select c.id,a.center_code ,c.centre_name,a.total as Total,b.total as R,b.totalp as P,total_Absent as A,U from 
        (
        SELECT center_code,count(roll_no) as total,d.id FROM std_subjects_$classprefix as s, date_sheet as d
        where s.subject_code= d.subject_code
        and d.paper_date = :pepDate and d.classid = :classid
        and d.shift = :shift and s.classid=d.classid
        group by center_code
        ) as a , 
        (
        SELECT a.center_code,count(distinct a.roll_no) as total,  COUNT( CASE WHEN (a.attendence_status=1 || a.attendence_status=2) then 1 end) as totalp , COUNT( CASE WHEN (a.attendence_status=9) then 1 end) as total_Absent
        ,(select count(*) from attendance where attendence_status is null and center_code=a.center_code and paper_date=a.paper_date) as U
FROM attendance as a
        where a.paper_date = :pepDate and a.classid = :classid
        and a.shift = :shift
        group by a.center_code
        ) as b,  
        (
        select * from exam_centres_$classprefix
        where classid=:classid
        ) as c where a.center_code = b.center_code  
        and a.center_code = c.centre_code order by c.id asc";
  if($penType==2)
    $query = "SELECT b.id,b.centre_code as center_code,b.centre_name FROM `staff_attendance` as a 
        inner join exam_centres_$classprefix as b on a.center=b.centre_code
        where a.paper_date=:pepDate  and a.classid=:classid and a.shift =:shift and b.classid=a.classid GROUP BY a.center";
  if($penType==3)
    $query = "SELECT b.id,b.centre_name,  a.center as center_code FROM `bundle_pictures` as a 
        inner join exam_centres_$classprefix as b on a.center=b.centre_code
        where a.paper_date=:pepDate  and a.classid=:classid and a.shift =:shift and b.classid=a.classid GROUP BY b.id";

  $RInformationList = $conn->prepare($query);
  $RInformationList->bindParam(':classid', $userclass);
  $RInformationList->bindParam(':pepDate', $pepDate);
  $RInformationList->bindParam(':shift', $shift);
  $RInformationList->execute();
  $RInformationList = $RInformationList->fetchAll(PDO::FETCH_ASSOC);
 $data['RInfo']=$RInformationList;
 print_r(json_encode($data));
}
if($requestType==55)   // Get a center attendance details
 {
  $userclass=$_POST['classid'];
  $pepDate= $_POST['pepDate'];
  $shift = $_POST['shift'];
  $detailsType=$_POST['detailsType'];
  $centerCode=$_POST['centerCode'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
  $data=array();
  $query = "SELECT DISTINCT(roll_no),script_number,attendence_status FROM `attendance` where  paper_date=:pepDate and classid=:classid and  center_code=:centerCode and shift =:shift and attendence_status <> 9  ORDER by roll_no";
  if($detailsType==2)   // absent students
    $query = "SELECT DISTINCT(roll_no) FROM `attendance` where  paper_date=:pepDate and classid=:classid and  center_code=:centerCode and shift =:shift and attendence_status = 9  ORDER by roll_no";
  if($detailsType==3)  // unsent students
    $query = "SELECT DISTINCT(b.roll_no) FROM `date_sheet` AS a INNER JOIN std_subjects_$classprefix AS b ON a.`subject_code` = b.subject_code WHERE a.`paper_date` =:pepDate AND a.classid =  b.classid AND b.classid = :classid   AND b.center_code=:centerCode and a.shift = :shift and b.roll_no not in (
                SELECT DISTINCT(roll_no) FROM `attendance` as c where c.center_code=b.center_code and c.classid=b.classid  and c.paper_date=a.`paper_date` and c.shift = :shift)
                ORDER by roll_no";
   if($detailsType==4)   // get staff attendance
    $query = "SELECT UPPER(b.name) as name ,d.user,c.attend_type FROM `staff_attendance` as a inner join staff as b  on a.staff_id=b.staff_id INNER join ref_staffatnd as c on a.attendence=c.attend_code INNER join ref_app_users as d on b.role=d.type_code where a.paper_date=:pepDate and a.classid=:classid and a.shift=:shift and a.center=:centerCode";
  if($detailsType==5)
    $query="SELECT a.pic,a.created,a.paper_date,a.pic_time FROM `bundle_pictures` a 
         where center=:centerCode and paper_date=:pepDate and a.classid=:classid and a.shift=:shift";
  $RInformationList = $conn->prepare($query);
  $RInformationList->bindParam(':centerCode', $centerCode);
  $RInformationList->bindParam(':classid', $userclass);
  $RInformationList->bindParam(':pepDate', $pepDate);
  $RInformationList->bindParam(':shift', $shift);
  $RInformationList->execute();
  $RInformationList = $RInformationList->fetchAll(PDO::FETCH_ASSOC);
  if($detailsType==5)
  {
    $length = count($RInformationList); 
    for ($x = 0; $x <$length; $x++) {
  $RInformationList[$x]["pic"]=$miscImagesLink.$RInformationList[$x]["pic"]."?alt=media";
}
  }
 $data['RInfo']=$RInformationList;
 print_r(json_encode($data));
}
if($requestType==56)   // Create session validation string
 {
$data=array();
$success=0;
$ismaster=0;
$access="";
$data = array("Success"=>0, "branchCode"=>"$branchCode","branchName"=>"$branchName","supName"=>"$supName");
$Token= $_POST['Token'];
$username= $_POST['username'];
$q2 = "select isSuperAdmin,access_pages from `admin` where admin_username=:admin_username and Active=1";
  $messages= $conn->prepare($q2);
  $messages->bindParam(':admin_username', $username);
  $messages->execute(); 
  $RInformationList = $messages->fetch(PDO::FETCH_ASSOC);
$enc_Token=encrypt_token($Token);
 $enc_Token = mb_convert_encoding($enc_Token, 'UTF-8');
 $enc_request = mb_convert_encoding($_POST['enc'], 'UTF-8');
  if($enc_Token==$enc_request && !empty($RInformationList))
    {
      $success=1;
      $ismaster=$RInformationList['isSuperAdmin'];
      $access=$RInformationList['access_pages'];
      $token=generateRandomToken(64);
      $_SESSION['session_token'] = $token;
    }
  $data = array("Success"=>$success, "access_pages"=>"$access","isSuperAdmin"=>$ismaster,"token"=>$token);
  print_r(json_encode($data));
}
if($requestType==61)   // Retrieve system admin
 {
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
$session=0; 
$suplist = [];
if($token==$sessionID && $access==true)
  {
  $query = "SELECT * FROM `admin`";
  $suplist = $conn->prepare($query);
  $suplist->execute();
  $suplist = $suplist->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
}
$data=array("Session"=>$session, "Adminslist"=>$suplist);
  print_r(json_encode($data));
}
if($requestType==62)   // add System User
 {
$data["Success"]=0;
$token=$_SESSION['session_token'];
$sessionID = $_POST['sessionID'];
$accessrequired=$_POST['accessrequired'];
$loggedin_username=$_POST['loggedin_username'];
$access=isAccess($conn,$loggedin_username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$sname = $_POST['sname'];
$userName = $_POST['userName'];
$password = md5($_POST['password']);
$isSuper = $_POST['isSuper'];
$accessPages = $_POST['accessPages'];
$query = "Select * from  `admin` WHERE `admin_username`=:userName";
  $change = $conn->prepare($query);
  $change->bindParam(':userName', $userName);
  $change->execute();
  $count_User = $change->rowCount();
if($count_User>0)
  $data["Success"]=2; // user already exist
else 
{
  $q2 = "INSERT INTO `admin` (`admin_nama`, `admin_username`, `admin_password`, `access_pages`, `isSuperAdmin`) 
VALUES (:admin_nama, :admin_username, :admin_password, :access_pages, :isSuperAdmin);";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':admin_nama', $sname);
      $report2->bindParam(':admin_username', $userName);
      $report2->bindParam(':admin_password', $password);
      $report2->bindParam(':access_pages', $accessPages);
      $report2->bindParam(':isSuperAdmin', $isSuper);
      $result2 = $report2->execute();
      if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
}  
print_r(json_encode($data));
}
if($requestType==63)   // update system user
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$loggedin_username=$_POST['loggedin_username'];
$access=isAccess($conn,$loggedin_username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$sname = $_POST['sname'];
$userName = $_POST['userName'];
$isSuper = $_POST['isSuper'];
$accessPages = $_POST['accessPages'];
 $q2 = "update `admin` set `admin_nama`=:admin_nama,`access_pages`=:access_pages, `isSuperAdmin`=:isSuperAdmin where admin_username=:admin_username";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':admin_nama', $sname);
      $report2->bindParam(':admin_username', $userName);
      $report2->bindParam(':access_pages', $accessPages);
      $report2->bindParam(':isSuperAdmin', $isSuper);
      $result2 = $report2->execute();
      if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
print_r(json_encode($data));
}
if($requestType==64)   // delete system admin
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$loggedin_username=$_POST['loggedin_username'];
$access=isAccess($conn,$loggedin_username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$AdminID = $_POST['AdminID'];
$q2 = "Delete from `admin` where admin_id=$AdminID";
  $messages= $conn->prepare($q2);
  $result = $messages->execute(); 
  $data["Success"]=1;
  print_r(json_encode($data));
}
if($requestType==65)   // change admin password
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$loggedin_username=$_POST['loggedin_username'];
$access=isAccess($conn,$loggedin_username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$AdminID = $_POST['AdminID'];
$oldpassword = $_POST['oldpassword'];
$newpassword = $_POST['newpassword'];
$q2 = "select admin_password from `admin` where admin_id=$AdminID";
  $messages= $conn->prepare($q2);
  $messages->execute(); 
  $RInformationList = $messages->fetchAll(PDO::FETCH_ASSOC);
  if($RInformationList[0]["admin_password"]!=$oldpassword)
    $data["Success"]=2;
  else 
  {
    $q2 = "update `admin` set `admin_password`=:admin_password where admin_id=:admin_id";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':admin_id', $AdminID);
      $report2->bindParam(':admin_password', $newpassword);
      $result2 = $report2->execute();
      if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
  }
  print_r(json_encode($data));
}
if($requestType==66)   // change admin password
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$loggedin_username=$_POST['loggedin_username'];
$access=isAccess($conn,$loggedin_username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$AdminID = $_POST['AdminID'];
$newpassword = $_POST['newpassword'];
 $q2 = "update `admin` set `admin_password`=:admin_password where admin_id=:admin_id";
      $report2 = $conn->prepare($q2);
      $report2->bindParam(':admin_id', $AdminID);
      $report2->bindParam(':admin_password', $newpassword);
      $result2 = $report2->execute();
      if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
  print_r(json_encode($data));
}
if($requestType==67)   // change admin password
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
if($token!=$sessionID)
  {
    print_r(json_encode($data));
    return;
}
$CenterNo = $_POST['CenterNo'];
$BCode = $_POST['BCode'];
$userclass=$_POST['classid'];
$tblName="exam_centres_ssc";
if($userclass==2)
$tblName="exam_centres_hssc";
 $q2 = "update $tblName set `campCode`=:campCode where id=:cno";
 $report2 = $conn->prepare($q2);
 $report2->bindParam(':campCode', $BCode);
 $report2->bindParam(':cno', $CenterNo);
 $result2 = $report2->execute();
 if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
  print_r(json_encode($data));
}
if($requestType==68)   // get a roll number attendance
 {
$sessionID = $_POST['sessionID'];
$roll_no = $_POST['roll_no'];
$userclass = $_POST['userclass'];
$token=$_SESSION['session_token'];
$attendanceList = [];
if($token==$sessionID)
  {
  $query = "SELECT a.id,a.roll_no,a.paper_date,a.shift,a.script_number,a.attendence_status,d.paper_name  FROM attendance a INNER join date_sheet d on a.sub_code=d.subject_code and a.classid=d.classid WHERE a.roll_no=:roll_no And a.classid=:classid and a.attendence_status in (1,2,9)";
  $attendanceList = $conn->prepare($query);
  $attendanceList->bindParam(':roll_no', $roll_no);
 $attendanceList->bindParam(':classid', $userclass);
  $attendanceList->execute();
  $attendanceList = $attendanceList->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
}
$data=array("Session"=>$session, "AttendanceList"=>$attendanceList);
  print_r(json_encode($data));
}
if($requestType==69)   // change answersheet number 
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$attendanceid = $_POST['attendanceid'];
$scriptnumber = $_POST['scriptnumber'];
if($token!=$sessionID)
  {
    print_r(json_encode($data));
    return;
}
 $q2 = "update attendance set `script_number`=:script_number where id=:attendanceid";
 $report2 = $conn->prepare($q2);
 $report2->bindParam(':script_number', $scriptnumber);
 $report2->bindParam(':attendanceid', $attendanceid);
 $result2 = $report2->execute();
 if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
  print_r(json_encode($data));
}
if($requestType==70)   // change attendance status and answersheet
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$attendanceid = $_POST['attendanceid'];
$scriptnumber = $_POST['scriptnumber'];
$attendence_status = $_POST['attendence_status'];
if($token!=$sessionID)
  {
    print_r(json_encode($data));
    return;
}
 $q2 = "update attendance set `script_number`=:script_number,`attendence_status`=:attendence_status where id=:attendanceid";
 $report2 = $conn->prepare($q2);
 $report2->bindParam(':script_number', $scriptnumber);
 $report2->bindParam(':attendanceid', $attendanceid);
 $report2->bindParam(':attendence_status', $attendence_status);
 $result2 = $report2->execute();
 if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
  print_r(json_encode($data));
}
if($requestType==71)   // retrieve sups for shufflings
 {
 $userclass=$_POST['classid'];
  $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
$session=0; 
$inspectorslist = [];
if($token==$sessionID && $access==true)
  {
     $query = "select s.userid,s.name,s.username,s.mobile,s.posting,s.designation,s.classid,s.status,s.active,isSetupComplete,c.id,c.centre_code,c.centre_name FROM app_user s inner join exam_centres_{$classprefix} c on s.center_code=c.centre_code WHERE s.type = 1 AND s.classid=:classid AND s.status=1 AND s.active=1 ORDER BY c.id ASC";
  $inspectorslist = $conn->prepare($query);
        $inspectorslist->bindParam(':classid', $userclass);
  $inspectorslist->execute();
  $inspectorslist = $inspectorslist->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
  }

 $data=$data=array("Session"=>$session, "supslist"=>$inspectorslist);
 print_r(json_encode($data));
}
if($requestType==72)   // shuffle superintendent.
 {
 $userID=$_POST['userID']; 
 $userclass=$_POST['classid'];
 $sessionID = $_POST['sessionID'];
 $MobileNumber = $_POST['MobileNumber'];
 $oldCenterCode = $_POST['oldCenterCode'];
 $NewCenter = $_POST['NewCenter'];
 $accessrequired=$_POST['accessrequired'];
 $username=$_POST['username'];
 $token=$_SESSION['session_token'];
 $role=1;
 $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
$access=isAccess($conn,$username,$accessrequired); 
$session=0; 
$cname="";
if(true==false)
    $session=0;   // session does not exist or no access
else 
{
$query = "Select centre_name,centre_code from  exam_centres_$classprefix WHERE id=$NewCenter";
  $query = $conn->prepare($query);
  $query->execute();
  $count=0;
  $count = $query->rowCount();
 if($count==0)
     $session=1;   // Means no center exist
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $centercode= $center[0]["centre_code"];
  $cname= $center[0]["centre_name"];
  $q = "update `app_user` set center_code=$centercode where userid=$userID";
  $staff = $conn->prepare($q);
  $result = $staff->execute();
  $q = "update `staff` set center_code=$centercode where center_code=$oldCenterCode AND role=$role AND classid=$userclass And mobile=$MobileNumber";
  $staff = $conn->prepare($q);
  $staff->execute();
  if($result)
    $session=2;   // update success
  else
    $session=3;  // query failure
 } 
}
 $data=array("Success"=>$session,"cname"=>$cname);
 print_r(json_encode($data));
}
if($requestType==73)   // invigilator duty slip
 {
  // warning: dont change anything that is enclosed in **.
 // warning: dont change anything that is enclosed in **.
  // warning: dont change anything that is enclosed in **.
 $staffID=$_POST['staffID']; 
 $userclass=$_POST['classid'];
 $sessionID = $_POST['sessionID'];
 $centerCode = $_POST['centerCode'];
 $role = $_POST['role'];
 $dutyno=str_replace("**number**", $staffID, $dutySlipNo);
 $imageData = file_get_contents($signaturePath);
 $base64Image = base64_encode($imageData);
 $examcode=1;
 $classprefix="ssc";
    if($userclass==2)
      $classprefix="hssc";
 $query = "Select exam_code from  std_subjects_$classprefix WHERE center_code=$centerCode Limit 1";
  $query = $conn->prepare($query);
  $query->execute();
  $count=0;
  $count = $query->rowCount();
 if($count==0)
     $examcode=1;   
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $examcode= $center[0]["exam_code"];
}
 $firstdate = "2024-03-04";
 $preparationDay="2024-03-03";
 $dutyintimationDate="2024-03-01";
 $query="Select  DATE_FORMAT(paper_date, '%D %M, %Y') AS startingdate,
    DATE_FORMAT(DATE_SUB(paper_date, INTERVAL 1 DAY), '%D %M, %Y') AS preparationday,
    DATE_FORMAT(DATE_SUB(paper_date, INTERVAL 4 DAY), '%D %M, %Y') AS intimationdate,YEAR(paper_date) AS examyear from `date_sheet` WHERE classid=$userclass ORDER by `paper_date` ASC Limit 1";
 $query = $conn->prepare($query);
 $query->execute();
 $count=0;
 $count = $query->rowCount();
 if($count==0)
     {
      $firstdate = "2024-03-04";
 $preparationDay="2024-03-03";
 $dutyintimationDate="2024-03-01";
     }
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $firstdate=$center[0]["startingdate"];
  $preparationDay=$center[0]["preparationday"];
  $dutyintimationDate=$center[0]["intimationdate"];
  $year = $center[0]["examyear"];
}
$memoText=str_replace("**firstdate**", $firstdate, $memoText_sup);
$memoText=str_replace("**prepdate**", $preparationDay, $memoText);

$showingTraining=true;
$trainingdate="14-10-2024";
$trainingTime="10:00 AM";
$trainingVenue="Board Office";
$query="Select  DATE_FORMAT(sup_training_datetime, '%D %M, %Y') AS trainingDate,
    DATE_FORMAT(sup_training_datetime, '%H:%i:%s') AS trainingTime,
    sup_training_venue AS trainingvenu
    from `App_Settings` WHERE classid=$userclass Limit 1";
 $query = $conn->prepare($query);
 $query->execute();
 $count=0;
 $count = $query->rowCount();
 if($count==0)
     {
 $trainingdate="14-10-2024";
  $trainingTime="10:00 AM";
  $trainingVenue="Board Office";
     }
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $trainingdate=$center[0]["trainingDate"];
  $trainingTime=$center[0]["trainingTime"];
  $trainingVenue=$center[0]["trainingvenu"];
}
$TrainingText=$TrainingText_sup;

 $TrainingText=str_replace("**trainingdate**", $trainingdate, $TrainingText);
 $TrainingText=str_replace("**trainingvenue**", $trainingVenue, $TrainingText);
 $TrainingText=str_replace("**trainingtime**", $trainingTime, $TrainingText);

$contactText=$contactText_SSC;
if($userclass==2)
$contactText=$contactText_HSSC;
$Notes=$Notes_sup;
foreach ($Notes as &$note) {
    $note = str_replace("**refusaldate**", $dutyintimationDate, $note);
}
$before_RulesText=$before_RulesText_supervisory;
$showingTraining=false;
$showingContact=false;
if($role==1 || $role==17)
{
  $rules=[$rule1,$rule2,$rule3,$rule4,$rule5,$rule6,$rule7,$rule8,$rule9,$rule10,$rule11];
  $showingTraining=true;
  $showingContact=true;
}
if($role==4 ||$role==5 ||$role==11)
{
  $rules=[$rule1,$rule2,$rule3,$rule4,$rule5,$rule6,$rule7,$rule8,$rule9,$rule10,$rule11];
  $showingTraining=false;
  $showingContact=false;
}

 $data=array("Success"=>$session,"headerline1"=>$headerline1,"headerline2"=>$headerline2,"headerline3"=>$headerline3,"subjectLine"=>$subjectline_supervisory,"memoText"=>$memoText,"displayTraining"=>$showingTraining,"TrainingText"=>$TrainingText,"showContact"=>$showingContact,"contactText"=>$contactText,"dutySlipNo"=>$dutyno,"examcode"=>$examcode,"examyear"=>$year,"examNameAppendingText"=>$examNameAppendingText,"before_RulesText"=>$before_RulesText,"rules"=>$rules,"before_billrequirement"=>$before_billrequirement,"billrequirement"=>$billrequirement,"signatoryName"=>$signatoryName,"signatoryDesignation"=>$signatoryDesignation,"Notes"=>$Notes,"signature"=>$base64Image);
 print_r(json_encode($data));
}
if($requestType==74)   // update staff posting and designation
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$staff_id = $_POST['staff_id'];
$designation = $_POST['designation'];
$posting = $_POST['posting'];
if($token!=$sessionID)
  {
    print_r(json_encode($data));
    return;
}
 $q2 = "update staff set `posting`=:posting,`designation`=:designation where staff_id=:staff_id";
 $report2 = $conn->prepare($q2);
 $report2->bindParam(':posting', $posting);
 $report2->bindParam(':designation', $designation);
 $report2->bindParam(':staff_id', $staff_id);
 $result2 = $report2->execute();
 if($result2)
    $data["Success"]=1; // success
  else
    $data["Success"]=3; // failed
  print_r(json_encode($data));
}
if($requestType==75)   // Exam inspector and Bank Inspector Duty slip
 {
  // warning: dont change anything that is enclosed in **.
 // warning: dont change anything that is enclosed in **.
  // warning: dont change anything that is enclosed in **.
 $userid=$_POST['staffID']; 
 $userclass=$_POST['classid'];
 $sessionID = $_POST['sessionID'];
 $role = $_POST['role'];
 $dutyno=str_replace("**number**", $userid, $dutySlipNo);
 $signaturePath='signature.jpg';
 $imageData = file_get_contents($signaturePath);
 $base64Image = base64_encode($imageData);
 $examNameAppendingText="";
 $before_RulesText=$before_RulesText_ins;
 $examcode=1;
 $classprefix="ssc";
  if($userclass==2)
      $classprefix="hssc";
 $query = "Select exam_code from  std_subjects_$classprefix Limit 1";
  $query = $conn->prepare($query);
  $query->execute();
  $count=0;
  $count = $query->rowCount();
 if($count==0)
     $examcode=1;   
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $examcode= $center[0]["exam_code"];
}
 $firstdate = "2024-03-04";
 $preparationDay="2024-03-03";
 $dutyintimationDate="2024-03-01";
 $query="Select  DATE_FORMAT(paper_date, '%D %M, %Y') AS startingdate,
    DATE_FORMAT(DATE_SUB(paper_date, INTERVAL 1 DAY), '%D %M, %Y') AS preparationday,
    DATE_FORMAT(DATE_SUB(paper_date, INTERVAL 4 DAY), '%D %M, %Y') AS intimationdate,YEAR(paper_date) AS examyear from `date_sheet` WHERE classid=$userclass ORDER by `paper_date` ASC Limit 1";
 $query = $conn->prepare($query);
 $query->execute();
 $count=0;
 $count = $query->rowCount();
 if($count==0)
     {
      $firstdate = "2024-03-04";
 $preparationDay="2024-03-03";
 $dutyintimationDate="2024-03-01";
     }
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $firstdate=$center[0]["startingdate"];
  $preparationDay=$center[0]["preparationday"];
  $dutyintimationDate=$center[0]["intimationdate"];
  $year = $center[0]["examyear"];
}
$duties=[];
$centersview="exam_centres_ssc";
if($userclas==2)
  $centersview="exam_centres_hssc";
$query="Select  c.id,c.centre_name,d.duty_date from inspectors_centres d inner join $centersview c on c.centre_code=d.centre where userid=$userid";
 $query = $conn->prepare($query);
 $query->execute();
 $duties = $query->fetchAll(PDO::FETCH_ASSOC);
 $firstdate = "2024-03-04";
 $preparationDay="2024-03-03";
 $dutyintimationDate="2024-03-01";
 $query="Select  DATE_FORMAT(paper_date, '%D %M, %Y') AS startingdate,
    DATE_FORMAT(DATE_SUB(paper_date, INTERVAL 1 DAY), '%D %M, %Y') AS preparationday,
    DATE_FORMAT(DATE_SUB(paper_date, INTERVAL 4 DAY), '%D %M, %Y') AS intimationdate,YEAR(paper_date) AS examyear from `date_sheet` WHERE classid=$userclass ORDER by `paper_date` ASC Limit 1";
 $query = $conn->prepare($query);
 $query->execute();
 $count=0;
 $count = $query->rowCount();
 if($count==0)
     {
      $firstdate = "2024-03-04";
 $preparationDay="2024-03-03";
 $dutyintimationDate="2024-03-01";
     }
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $firstdate=$center[0]["startingdate"];
  $preparationDay=$center[0]["preparationday"];
  $dutyintimationDate=$center[0]["intimationdate"];
  $year = $center[0]["examyear"];
}
$showingTraining=true;
$trainingdate="14-10-2024";
$trainingTime="10:00 AM";
$trainingVenue="Board Office";
$query="Select  DATE_FORMAT(examinspector_training_datetime, '%D %M, %Y') AS trainingDate,
    DATE_FORMAT(examinspector_training_datetime, '%H:%i:%s') AS trainingTime,
    examinspector_training_venue AS trainingvenu
    from `App_Settings` WHERE classid=$userclass Limit 1";
 $query = $conn->prepare($query);
 $query->execute();
 $count=0;
 $count = $query->rowCount();
 if($count==0)
     {
 $trainingdate="14-10-2024";
  $trainingTime="10:00 AM";
  $trainingVenue="Board Office";
     }
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $trainingdate=$center[0]["trainingDate"];
  $trainingTime=$center[0]["trainingTime"];
  $trainingVenue=$center[0]["trainingvenu"];
}
$contactText=$contactText_SSC;
if($userclass==2)
$contactText=$contactText_HSSC;
$TrainingText=$TrainingText_ins;
$TrainingText=str_replace("**trainingdate**", $trainingdate, $TrainingText);
$TrainingText=str_replace("**trainingvenue**", $trainingVenue, $TrainingText);
$TrainingText=str_replace("**trainingtime**", $trainingTime, $TrainingText);
$showingTraining=false;
$showingContact=false;
if($role==3)
{
  $rules=[$rule12,$rule13,$rule14,$rule15,$rule16,$rule17,$rule18,$rule19,$rule20,$rule21];
  $showingTraining=true;
  $showingContact=true;
}
if($role==7)
{
  $rules=[$rule1,$rule2,$rule3,$rule4,$rule5,$rule6,$rule7,$rule8,$rule9,$rule10,$rule11];
  $showingTraining=true;
  $showingContact=true;
}
 $data=array("Success"=>$session,"headerline1"=>$headerline1,"headerline2"=>$headerline2,"headerline3"=>$headerline3,"subjectLine"=>$subjectline_Examinspectors,"memoText"=>$memoText_ins,"displayTraining"=>$showingTraining,"TrainingText"=>$TrainingText,"showContact"=>$showingContact,"contactText"=>$contactText,"acceptanceText"=>$acceptanceText_ins,"dutySlipNo"=>$dutyno,"examcode"=>$examcode,"examyear"=>$year,"examNameAppendingText"=>$examNameAppendingText,"before_RulesText"=>$before_RulesText,"rules"=>$rules,"showbillrequirement"=>false,"before_billrequirement"=>$before_billrequirement,"billrequirement"=>$billrequirement,"signatoryName"=>$signatoryName,"signatoryDesignation"=>$signatoryDesignation,"Notes"=>$Notes_ins,"signature"=>$base64Image);
 print_r(json_encode($data));
}
if($requestType==79)   // update app settings
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];

$userclass=$_POST['classid'];
$sup_date=$_POST['sup_date'];
$ins_date=$_POST['ins_date'];
$bank_date=$_POST['bank_date'];
$sup_venu=$_POST['sup_venu'];
$ins_venu=$_POST['ins_venu'];
$bank_venu=$_POST['bank_venu'];

$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
$q = "Update `App_Settings` set `sup_training_datetime`=:sup_training_datetime,`sup_training_venue`=:sup_training_venue, `examinspector_training_datetime`=:examinspector_training_datetime, `examinspector_training_venue`=:examinspector_training_venue, `bankinspector_training_datetime`=:bankinspector_training_datetime, `bankinspector_training_venue`=:bankinspector_training_venue where classid=:classid";
      $record = $conn->prepare($q);
      $record->bindParam(':sup_training_datetime', $sup_date);
      $record->bindParam(':sup_training_venue', $sup_venu);
      $record->bindParam(':examinspector_training_datetime', $ins_date);
      $record->bindParam(':examinspector_training_venue', $ins_venu);
      $record->bindParam(':bankinspector_training_datetime', $bank_date);
      $record->bindParam(':bankinspector_training_venue', $bank_venu);
      $record->bindParam(':classid', $userclass);
      $result = $record->execute();
   if($result)
    $data["Success"]=1;
   else
    $data["Success"]=0;
print_r(json_encode($data));
}
if($requestType==80)   //Exam Setup and Manual
 {
  // warning: dont change anything that is enclosed in **.
 // warning: dont change anything that is enclosed in **.
  // warning: dont change anything that is enclosed in **.
 $Success=0;
 $userclass=$_POST['classid'];
 $sessionID = $_POST['sessionID'];
 $sup_training_datetime = "2024-03-04";
 $examinspector_training_datetime="2024-03-03";
 $bankinspector_training_datetime="2024-03-01";
 $sup_venu="";
 $exam_venu="";
 $bank_venu="";
 $query="Select  sup_training_datetime,sup_training_venue,examinspector_training_datetime,examinspector_training_venue,bankinspector_training_datetime,bankinspector_training_venue from `App_Settings` WHERE classid=$userclass ORDER by `ID` ASC Limit 1";
 $query = $conn->prepare($query);
 $query->execute();
 $count=0;
 $count = $query->rowCount();
 if($count==0)
     {
$Success=0;
 $sup_training_datetime = "2024-03-04";
 $examinspector_training_datetime="2024-03-03";
 $bankinspector_training_datetime="2024-03-01";
 $sup_venu="";
     }
 else 
 {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $sup_training_datetime=$center[0]["sup_training_datetime"];
  $examinspector_training_datetime=$center[0]["examinspector_training_datetime"];
  $bankinspector_training_datetime=$center[0]["bankinspector_training_datetime"];
  $sup_venu=$center[0]["sup_training_venue"];
  $exam_venu=$center[0]["examinspector_training_venue"];
  $bank_venu=$center[0]["bankinspector_training_venue"];
  $Success=1;
}

 $data=array("Success"=>$Success,"sup_training_datetime"=>$sup_training_datetime,"examinspector_training_datetime"=>$examinspector_training_datetime,"bankinspector_training_datetime"=>$bankinspector_training_datetime,"sup_venu"=>$sup_venu,"exam_venu"=>$exam_venu,"bank_venu"=>$bank_venu);
 print_r(json_encode($data));
}
if($requestType==81)   // retrieve QR Batches
 {
 $userclass=$_POST['classid'];
 $sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$access=isAccess($conn,$username,$accessrequired); 
$session=0; 
$qr_batch_list = [];
if($token==$sessionID && $access==true)
  {
     $stmnt = "select batch_ID,generated_by,generated_on,classid,active FROM qr_batch WHERE classid=:classid ORDER BY active DESC";
     $stmnt = $conn->prepare($stmnt);
     $stmnt->bindParam(':classid', $userclass);
    $stmnt->execute();
  $qr_batch_list = $stmnt->fetchAll(PDO::FETCH_ASSOC);
  $session=1; 
  }

 $data=array("Session"=>$session, "batchlist"=>$qr_batch_list);
 print_r(json_encode($data));
}
if($requestType==82)   // Generate QR Batch
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$userclass=$_POST['classid'];

$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
  $q = "INSERT INTO `qr_batch`(`classid`, `generated_by`) VALUES (:userclass, :generated_by)";
      $record = $conn->prepare($q);
      $record->bindParam(':userclass', $userclass);
      $record->bindParam(':generated_by', $username);
      $result = $record->execute();
      $batch_id = $conn->lastInsertId();
   if($result)
    {
      // now make all the other batch ids inactive.
      $result=false;
      $q = "update `qr_batch` set active=0 where classid=:userclass and batch_ID<>:batch_ID";
      $record = $conn->prepare($q);
      $record->bindParam(':userclass', $userclass);
      $record->bindParam(':batch_ID', $batch_id);
      $result = $record->execute(); 
    }
  // again check result
  if($result)
    $data["Success"]=1; 
  else 
    $data["Success"]=0; 
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==83)   // Generate content for QR Code print.
 {
  // warning: dont change anything that is enclosed in **.
 // warning: dont change anything that is enclosed in **.
  // warning: dont change anything that is enclosed in **.
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$batch_ID=$_POST['batch_ID'];
$userclass=$_POST['classid'];
$centerview=$userclass==1?"exam_centres_ssc":"exam_centres_hssc";
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    $data=array("Success"=>0);
    print_r(json_encode($data));
    return;
}
else 
{
  $instructions=["This is a 'ONE TIME' $appName login QR code. (ONLY SUPERINTENDENTS)","Open $appName app in your mobile. In Login screen, Press QR Code Login. Scan the QR code given below.","Keep this QR code confidential to avoid any un-authorized access.","Although this QR code can only be used only once but its always better to spoil the QR code page to avoid any tempering or misuse.","In case of any problem, contact support staff."];

$query="Select v.id,v.centre_name,qr.passcode from qr_logins qr inner join $centerview v on qr.center_code=v.centre_code where qr.batch_ID=:batch_ID";
 $query = $conn->prepare($query);
 $query->bindParam(':batch_ID', $batch_ID);
 $query->execute();
 $QR_codes = $query->fetchAll(PDO::FETCH_ASSOC);
 $data=array("Success"=>1,"batch_ID"=>$batch_ID,"instructions"=>$instructions,"headerline1"=>$headerline1,"headerline2"=>$headerline2,"headerline3"=>$headerline3,"QR_Codes"=>$QR_codes);
 print_r(json_encode($data));
}
}
if($requestType==84)   // Generate QR Batch
 {
$data["Success"]=0;
$sessionID = $_POST['sessionID'];
$token=$_SESSION['session_token'];
$accessrequired=$_POST['accessrequired'];
$username=$_POST['username'];
$userclass=$_POST['classid'];
$batch_ID=$_POST['batch_ID'];
$access=isAccess($conn,$username,$accessrequired); 
if($token!=$sessionID || $access!=true)
  {
    print_r(json_encode($data));
    return;
}
   $q = "update `qr_batch` set active=1 where classid=:userclass and batch_ID=:batch_ID";
      $record = $conn->prepare($q);
      $record->bindParam(':userclass', $userclass);
      $record->bindParam(':batch_ID', $batch_ID);
      $result = $record->execute(); 
   if($result)
    {
      // now make all the other batch ids inactive.
      $result=false;
     $q = "update `qr_batch` set active=0 where classid=:userclass and batch_ID<>:batch_ID";
      $record = $conn->prepare($q);
      $record->bindParam(':userclass', $userclass);
      $record->bindParam(':batch_ID', $batch_ID);
      $result = $record->execute(); 
    }
  // again check result
  if($result)
    $data["Success"]=1; 
  else 
    $data["Success"]=0; 
   print_r(json_encode($data));
    $conn = null;
}
}
else {
  echo "Invalid access";
  $conn = null;
}


function encrypt_token($payload) {
  $key = '0123456789abcdef0123456789abcdef'; // 32 bytes key
$iv = '1234567890abcdef';
  $cipher = "aes-256-cbc";
    $options = OPENSSL_RAW_DATA;
    $encrypted = openssl_encrypt($payload, $cipher, $key, $options, $iv);
    return base64_encode($encrypted);
}
function generateRandomToken($length = 64) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $token = '';
    for ($i = 0; $i < $length; $i++) {
        $token .= $characters[mt_rand(0, strlen($characters) - 1)];
    }
    return $token;
}
function isAccess($dbcon,$username,$accessTag) {
  $q2 = "SELECT access_pages 
           FROM `admin` 
           WHERE admin_username = :admin_username 
             AND Active = 1 
             AND (isSuperAdmin = 1 OR access_pages LIKE CONCAT('%', :access, '%'))";
  $messages= $dbcon->prepare($q2);
  $messages->bindParam(':admin_username', $username);
  $messages->bindParam(':access', $accessTag);
  $messages->execute(); 
  $RInformationList = $messages->fetch(PDO::FETCH_ASSOC);
  if(!empty($RInformationList))
    return true;
  else
    return false;
}
?>