<?php
include_once 'config.php';
$data = array();
$key = $_REQUEST['authkey'];
$requestType = $_REQUEST['requestType'];
if ($authkey == $key) {
  if($requestType==1)   // Check if Staff Management is allowed.
 {
  $settings = "select ID, SettingsName,classid, AllowStaffManagement, AllowStaffShuffling  FROM App_Settings where isSettingActive=1";
  $settings = $conn->prepare($settings);

  $settings->execute();
  $count_settings = $settings->rowCount();
  if ($count_settings > 0) {
    $setRows = $settings->fetchAll(PDO::FETCH_ASSOC);
    $data['settings'] = $setRows;
  }
  else {
        $data['settings'] = [];
  }
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==2)
 {
  $msg=0;
  $Name = $_REQUEST['Name'];
  $mobileNumber = $_REQUEST['mobileNumber'];
  $role = $_REQUEST['role'];
  $centerCode = $_REQUEST['centerCode'];
  $CNICNumber = $_REQUEST['CNICNumber'];
  $ac_no = $_REQUEST['ac_no'];
  $added_by = $_REQUEST['added_by'];
  $posting = $_REQUEST['posting'];
  $classid = $_REQUEST['classid'];
  
  // first check if staff already exist in same center 
  $query = "Select * from  `staff` WHERE (`mobile`=:mobileNumber OR cnic=:CNICNumber) AND classid=:classid and active=1";
  $query = $conn->prepare($query);
  $query->bindParam(':mobileNumber', $mobileNumber);
  $query->bindParam(':CNICNumber', $CNICNumber);
  $query->bindParam(':classid', $classid);
  $query->execute();
  $count_staff=0;
  $count_staff = $query->rowCount();
  if ($count_staff>0) 
   {
    $stafflist = $query->fetchAll(PDO::FETCH_ASSOC);
    $data["Newstaff"]=[];
    if($centerCode==$stafflist[0]["center_code"])
    {
      $data["Message"]=4;  //staff exist in same center. need to refresh 
    }
    else 
    {
      $data["Message"]=3; //already exist in other center.
    }
   }
  else {
  $q = "INSERT INTO `staff`(`name`, `mobile`, `role`, `center_code`, `cnic`, `ac_no`, `added_by`, `adress`, `classid`,`active`,`ConfirmationStatus`) VALUES (:name, :mobile, :role, :center_code, :cnic,:account,:added_by, :posting,:classid,1,1)";
      $record = $conn->prepare($q);
      $record->bindParam(':name', $Name);
      $record->bindParam(':mobile', $mobileNumber);
      $record->bindParam(':role', $role);
      $record->bindParam(':center_code', $centerCode);
      $record->bindParam(':cnic', $CNICNumber);
      $record->bindParam(':account', $ac_no);
      $record->bindParam(':added_by', $added_by);
      $record->bindParam(':posting', $posting);
      $record->bindParam(':classid', $classid);
      $result = $record->execute();
     if($result)
      {
      $staff = "SELECT `staff_id` FROM `staff` WHERE `classid`=:classid and `center_code`=:center_code and`active`=:active And (`mobile`=:mobile OR cnic=:cnic)";
      $active = 1;
      $ConfirmationStatus = 1;
      $staff = $conn->prepare($staff);
      $staff->bindParam(':classid', $classid);
      $staff->bindParam(':center_code', $centerCode);
      $staff->bindParam(':active', $active);
      $staff->bindParam(':mobile', $mobileNumber);
      $staff->bindParam(':cnic', $CNICNumber);
      $staff->execute();
      $stafflist = $staff->fetchAll(PDO::FETCH_ASSOC); 
      $data["Message"]=1;   // Successfull insertion
      $data["staff_id"]=$stafflist[0]["staff_id"];
      }
      else {
      $data["Message"]=2;   // Database error 
      $data["staff_id"]=[];
      }
}
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==3)  //delete // deactivate an invigilator
 {
  $staff_id = $_REQUEST['staff_id'];
  $userid =   $_REQUEST['userid'];
  $q = "update `staff` set `active`=0,ConfirmationStatus=0,added_by=:added_by where staff_id=:staff_id";
  $staff = $conn->prepare($q);
  $staff->bindParam(':staff_id', $staff_id);
  $staff->bindParam(':added_by', $userid);
  $result = $staff->execute();
  if($result)
  {
    $data["Message"]=1;  // Updated succesffully
  }
  else 
  {
    $data["Message"]=0;
  }
   print_r(json_encode($data));
    $conn = null;
}
if($requestType==4)  //Change Center
 {
  $centerNo = $_REQUEST['centerNo'];
  $userid =   $_REQUEST['userID'];
  $classID =  $_REQUEST['classid'];
  $staff_id = $_REQUEST['staff_id'];
  $classPrefix="_ssc";
  if($classID==2)
    $classPrefix="_hssc";
  // first retrieve centercode.
  $data["Message"]=0;
  $query = "Select centre_code from  exam_centres$classPrefix WHERE id=$centerNo";
  $query = $conn->prepare($query);
  $query->execute();
  $count=0;
  $count = $query->rowCount();
  if ($count>0) 
   {
  $center = $query->fetchAll(PDO::FETCH_ASSOC);
  $centercode= $center[0]["centre_code"];
  $q = "update `staff` set center_code=$centercode where staff_id=$staff_id";
  $staff = $conn->prepare($q);
  $result = $staff->execute();
  if($result)
  $data["Message"]=1;  // Updated succesffully
  else 
    $data["Message"]=0;
}
else $data["Message"]=2;
   print_r(json_encode($data));
    $conn = null;
}
 if($requestType==5)   // Get Staff details based on Staff ID.
 {
  $staff_id = $_REQUEST['staff_id'];
  $query = "select staff_id,name, mobile, cnic,role,ac_no,adress FROM staff where staff_id=$staff_id";
  $query = $conn->prepare($query);
  $query->execute();
  $count_staff = $query->rowCount();
  if ($count_staff > 0) {
    $staffList = $query->fetchAll(PDO::FETCH_ASSOC);
    $data['StaffList'] = $staffList;
  }
  else {
        $data['StaffList'] = [];
  }
  print_r(json_encode($data));
    $conn = null;
 }
 if($requestType==6)   // update based on Staff ID.
 {
  $data['Message'] = 0;
  $staff_id = $_REQUEST['staff_id'];
  $role = $_REQUEST['role'];
  $name = $_REQUEST['name'];
  $mobile = $_REQUEST['mobile'];
  $cnic = $_REQUEST['cnic'];
  $ac_no = $_REQUEST['ac_no'];
  $posting = $_REQUEST['posting'];
  $added_by = $_REQUEST['added_by'];
  $query = "select staff_id FROM staff where (mobile=:mobile OR cnic=:cnic) AND staff_id<>:staff_id";
  $query = $conn->prepare($query);
  $query->bindParam(':mobile', $mobile);
  $query->bindParam(':cnic', $cnic);
  $query->bindParam(':staff_id', $staff_id);
  $query->execute();
  $count_staff = $query->rowCount();
  if ($count_staff > 0) {
    $data['Message'] = -1;  // Already exist
  }
  else {
   $query = "update staff set name=:name,mobile=:mobile,cnic=:cnic,ac_no=:ac_no,adress=:posting,added_by=:added_by where staff_id=:staff_id";
  $query = $conn->prepare($query);
  $query->bindParam(':name', $name);
  $query->bindParam(':mobile', $mobile);
  $query->bindParam(':cnic', $cnic);
  $query->bindParam(':ac_no', $ac_no);
  $query->bindParam(':posting', $posting);
  $query->bindParam(':added_by', $added_by);
  $query->bindParam(':staff_id', $staff_id);
  $result = $query->execute();
  if($result)
     $data['Message'] = 1;
  else $data['Message'] = 0;
  }
  print_r(json_encode($data));
    $conn = null;
 }
}
else {
  echo "Invalid access";
  $conn = null;
}

?>