<?php
include_once 'config.php';
header("Content-Type: application/json");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization");

$key = $_POST['authkey'];
$isnotification = $_POST['isnotification'];
$suggestedName = $_POST['suggestedName'] ?? null; // Get suggestedName from POST, default to null if not provided

$data = json_decode(file_get_contents("php://input"), true); // Collect input parameters and convert into readable format

if ($authkey == $key) {
    $fileName = $_FILES['sendimage']['name'];
    $tempPath = $_FILES['sendimage']['tmp_name'];
    $fileSize = $_FILES['sendimage']['size'];

    if (empty($fileName)) {
        $errorMSG = json_encode(array("message" => "Please select an image", "status" => false));
        echo $errorMSG;
    } else {
        $upload_path = '../store/misc/';
       if ($isnotification==1) {
            $upload_path = '../store/notifications/'; // Set upload folder path for notifications
        }

        $fileExt = strtolower(pathinfo($fileName, PATHINFO_EXTENSION)); // Get image extension

        // Valid image extensions
        $valid_extensions = array('jpeg', 'jpg', 'png', 'gif');

        // Allow valid image file formats
        if (in_array($fileExt, $valid_extensions)) {
            // Use suggestedName if provided, otherwise use the original file name
            $newFileName = $suggestedName ? $suggestedName: $fileName;

            // Check if file does not already exist in the upload folder path
            if (!file_exists($upload_path . $newFileName)) {
                // Check file size '2MB'
                if ($fileSize < 2000000) {
                    move_uploaded_file($tempPath, $upload_path . $newFileName); // Move file to upload folder path
                } else {
                    $errorMSG = json_encode(array("message" => "Sorry, your file is too large. Please upload a file less than 2 MB.", "status" => false));
                    echo $errorMSG;
                }
            } else {
                $errorMSG = json_encode(array("message" => "Sorry, file already exists. Check the upload folder.", "status" => false));
                echo $errorMSG;
            }
        } else {
            $errorMSG = json_encode(array("message" => "Sorry, only JPG, JPEG, PNG & GIF files are allowed.", "status" => false));
            echo $errorMSG;
        }
    }

    // If no error occurred, continue...
    if (!isset($errorMSG)) {
	$downloadpath=$notificationImagesLink.$newFileName;
        echo json_encode(array("message" => "Image Uploaded Successfully", "status" => true,"dpath"=> $downloadpath));
        $conn = null;
    }
} else {
    echo "Invalid access";
    $conn = null;
}