
<?php
include_once 'config.php';

$prac_students = array();
$key = $_REQUEST['authkey'];
$center = $_REQUEST['center'];
$classid = $_REQUEST['classid'];
$userid = $_REQUEST['userid'];

if ($classid == 1) {
  $examcode1 = 3;
  $examcode2 = 4;
} else if ($classid == 2) {
  $examcode1 = 5;
  $examcode2 = 6;
}

if ($authkey == $key) {

  $prac_std = "SELECT `id`, `st_name`, `f_name`, `batch`, `serial`, `dob`, `year`, `exam_session`, `classid`, `exam_code`, `roll_no`, `reg_no`, `subject_code`, `center_code`,`prac_date`,`start_time`,`end_time` FROM `std_subjects_prac` where (classid=:classid or`exam_code` in (:exam_code1,:exam_code2)) and center_code =:center_code and subject_code in(SELECT sub_code from app_user_prac_subs WHERE userid=:userid) order by exam_code,roll_no";
  $prac_ref = "SELECT  `id`,`sub_code`, `sub_des`, `max_marks` FROM `ref_sub_prac` where `classid`=:classid";
  $queryref = $conn->prepare($prac_ref);
  $queryref->bindParam(':classid', $classid);
  $queryref->execute();
  $countref = $queryref->rowCount();

  $queryp = $conn->prepare($prac_std);
  $queryp->bindParam(':classid', $classid);
  $queryp->bindParam(':exam_code1', $examcode1);
  $queryp->bindParam(':exam_code2', $examcode2);
  $queryp->bindParam(':center_code', $center);
  $queryp->bindParam(':userid', $userid);
  $queryp->execute();
  $countp = $queryp->rowCount();

  if ($countp > 0 && $countref > 0) {
    $resultp = $queryp->fetchAll(PDO::FETCH_ASSOC);
    $i = 0;
    foreach ($resultp as $row) {
      if ($row['exam_code'] == 3) {

        $folder = "SSC-I";
      } else if ($row['exam_code'] == 4) {

        $folder = "SSC-II";
      } else if ($row['exam_code'] == 5) {

        $folder = "HSSC-I";
      } else if ($row['exam_code'] == 6) {

        $folder = "HSSC-II";
      }

      $students[$i]['id'] = $row['id'];
      $students[$i]['st_name'] = $row['st_name'];
      $students[$i]['f_name'] = $row['f_name'];
      $students[$i]['dob'] = $row['dob'];
      $students[$i]['year'] = $row['year'];
      $students[$i]['exam_session'] = $row['exam_session'];
      $students[$i]['classid'] = $row['classid'];
      $students[$i]['exam_code'] = $row['exam_code'];
      $students[$i]['roll_no'] = $row['roll_no'];
      $students[$i]['reg_no'] = $row['reg_no'];
      $students[$i]['subject_code'] = $row['subject_code'];

      $students[$i]['center_code'] = $row['center_code'];
      $students[$i]['prac_date'] = $row['prac_date'];
      $students[$i]['start_time'] = $row['start_time'];
      $students[$i]['end_time'] = $row['end_time'];
      $students[$i]['picture'] = getStudentImageName($row);
      $students[$i]['picturelink'] = getStudentImageLink($row);    
      $i++;
    }



    $resultref = $queryref->fetchAll(PDO::FETCH_ASSOC);


    $prac_students['prac_std'] = $students;
    $prac_students['prac_ref'] = $resultref;
    $prac_students['code'] = '1';
    // print_r('<pre>');
    // print_r($theorystudents);
    print_r(json_encode($prac_students));
    $conn = null;
  } else {
    $prac_students['prac_std'] = [];
    $prac_students['prac_ref'] = [];
    $prac_students['code'] = '0';
    print_r(json_encode($prac_students));
    $conn = null;
  }
} else {
  echo "Invalid access";
  $conn = null;
}

?>











































