<?php
include_once 'config.php';
$theorystudents = array();
$key = $_REQUEST['authkey'];
$roll_no = $_REQUEST['roll_no'];
$classid = $_REQUEST['classid'];
date_default_timezone_set("Asia/Karachi");
$time = date('H:i:s');
if (!empty($_REQUEST['gmt'])) {
  $gmt = $_REQUEST['gmt'] - 5;
} else {
  $gmt = 0;
}
$currentdate = date('Y-m-d');
if ($classid == 1) {
  $examcode1 = 3;
  $examcode2 = 4;
} else if ($classid == 2) {
  $examcode1 = 5;
  $examcode2 = 6;
}
$classprefix="ssc";
if($classid==2)
  $classprefix="hssc";
if ($authkey == $key) {
  $theory_std = "SELECT a.`id`, `st_name`, `f_name`, `batch`, `serial`, `dob`, `year`, `exam_session`, a.`classid`, `exam_code`, `roll_no`, `reg_no`, a.`subject_code`, `center_code`,b.`paper_name`, b.`subject_code`, b.`classid`, b.`paper_date`, b.`start_time`, b.`end_time`, b.`shift` FROM `std_subjects_$classprefix` as a inner join `date_sheet` as b on a.subject_code=b.subject_code where (a.classid=:classid or`exam_code` in (:exam_code1,:exam_code1)) and roll_no =:roll_no and b.`paper_date`=CURRENT_DATE() and b.classid=:classid";

  $queryt = $conn->prepare($theory_std);
  $queryt->bindParam(':classid', $classid);
  $queryt->bindParam(':exam_code1', $examcode1);
  $queryt->bindParam(':exam_code2', $examcode2);
  $queryt->bindParam(':roll_no', $roll_no);
  $queryt->execute();
  $countt = $queryt->rowCount();

  if ($countt > 0) {
    $resultt = $queryt->fetchAll(PDO::FETCH_ASSOC);
    $i = 0;
    foreach ($resultt as $row) {
      $students[$i]['id'] = $row['id'];
      $students[$i]['st_name'] = $row['st_name'];
      $students[$i]['f_name'] = $row['f_name'];
      $students[$i]['dob'] = $row['dob'];
      $students[$i]['year'] = $row['year'];
      $students[$i]['exam_session'] = $row['exam_session'];
      $students[$i]['classid'] = $row['classid'];
      $students[$i]['exam_code'] = $row['exam_code'];
      $students[$i]['roll_no'] = $row['roll_no'];
      $students[$i]['reg_no'] = $row['reg_no'];
      $students[$i]['subject_code'] = $row['subject_code'];
      $students[$i]['paper_name'] = $row['paper_name'];
      $students[$i]['paper_date'] = $row['paper_date'];
      $students[$i]['shift'] = $row['shift'];
      $students[$i]['picture'] = $row['reg_no'] . ".jpg";
      $students[$i]['picture'] = getStudentImageName($row);
      $students[$i]['picturelink'] = getStudentImageLink($row);    
      $i++;
    }
    $theorystudents['theory_std'] = $students;
    $theorystudents['code'] = '1';
    // print_r('<pre>');
    // print_r($theorystudents);
    print_r(json_encode($theorystudents));
    $conn = null;
  } else {
    $theorystudents['theory_std'] = [];

    $theorystudents['code'] = '0';
    print_r(json_encode($theorystudents));
    $conn = null;
  }
} else {
  echo "Invalid access";
  $conn = null;
}

?>











































